#!/usr/bin/php -f
<?php
require "../php_lib/lib_orb.php";
require "../php_lib/lib_muxy.php";

function show_usage()
{
	echo "dvb_scan.php [socket <path to socket>] [country <country>] [output <output file>] [channel <file file>] [channel <channel number>] [rescan]\n";
}

$sock = $muxy_default;
$country = "";
$output_file = "";
$channel_file = "";
$channel = "";
$rescan = false;

$pram = "";
$value = false;
foreach($_SERVER["argv"] as $i => $arg)
{
	if($i == 0)
	{
		// skip prog name
	}
	else if($value)
	{
		//echo "$pram = $arg\n";
		$value = false;
		if($pram == "socket")
		{
			$sock = $arg;
		}
		else if($pram == "country")
		{
			$country = $arg;
		}
		else if($pram == "output")
		{
			$output_file = $arg;
		}
		else if($pram == "file")
		{
			$channel_file = $arg;
		}
		else if($pram == "channel")
		{
			$channel = $arg;
		}
		else
		{
			show_usage();
			die;
		}
	}
	else
	{
		if($arg == "rescan")
		{
			echo "Doing rescan only\n";
			$rescan = true;
		}
		else
		{
			$pram = $arg;
			$value = true;
		}
	}
}
if($value)
{
	show_usage();
	die;
}

//$sock = "/tmp/video/muxy0.sock";
$r = muxy($sock, "show country");

if($country == "")
{
	$country = $r['country'];
}

echo "Muxy DVB Scan for $country\n";

//$channels = file($country);

if($channel_file == "")
{
	$channel_file = "/usr/share/doc/muxy-0.10/$country";
}
$channels = file($channel_file);

$verbose = false;

$progress = array("\r  /", "\r  -", "\r  \\", "\r  |", "\r   \r");

/*
0 = Spectrum
1 = Band
2 = Channel
3 = Lo Hz
4 = Hi Hz
5 = Bandwidth MHz
6 = Centre Hz
7 = Suitable
8 = Comments
*/


function check_set_database($table, $keys, $key_values, $param, $param_value)
{
	global $orb;

	load_database();

	$where = "";
	foreach($keys as $i => $k)
	{
		if(strlen($where) > 0)
		{
			$where.= " AND ";
		}
		$where.= "$k = '".$key_values[$i]."'";
	}

	$sql = "SELECT COUNT(*) FROM $table WHERE $where";
	//echo "$sql;\n";
	$count = $orb->execute_count($sql);
	if($count == 0)
	{
		//echo "# Insert required\n";
		$sql = "INSERT INTO $table (".implode($keys, ", ").", $param) VALUES ('".implode($key_values, "', '")."', '$param_value')";
		#echo "$sql;\n";
		return $sql;
	}
	else if($count == 1)
	{
		// see if we need to update the value
		$sql = "SELECT $param FROM $table WHERE $where";
		$current = $orb->execute_count($sql);
		if(strcmp($param_value, $current) == 0)
		{
			//echo "# Value is already $current\n";
		}
		else
		{
			$sql = "UPDATE $table SET $param = '$param_value' WHERE $where";
			#echo "$sql;\n";
			return $sql;
		}
	}
	else
	{
		echo "# Found $count matching rows. Key is not unique\n";
	}
	return false;
}

function get_group_for_channel($chan)
{
	global $orb;

	$sql = "SELECT group_id FROM tbl_channel_tuner WHERE tuner_class = 'dvb' AND channel_id='$chan'";
	$group = $orb->execute_count($sql);
	if($group == "")
	{
		$sql = "SELECT COUNT(*) FROM tbl_channel_tuner WHERE group_id='$chan'";
		if($orb->execute_count($sql) == 0)
		{
			return $group;
		}

		# Someone else is using our channel number as their group number. Make sure we select an unused group id...?
/*		$group = 100;
		while($group < 200)
		{
			$sql = "SELECT COUNT(*) FROM tbl_channel_tuner WHERE group_id='$group'";
			if($orb->execute_count($sql) == 0)
			{
				return $group;
			}
			$group++;
		}
		// if we get here we are in trouble
		echo "Can't pick a group ID for channel $chan\n";
		die;*/
		return 100 + $chan;
	}
	else
	{
		return $group;
	}
}

$output = array();
if($channel == "")
{
	$output[] = "DELETE FROM tbl_channel";
	$output[] = "DELETE FROM tbl_channel_tuner";
	$output[] = "DELETE FROM tbl_channel_identifier";
}

$output2 = array();

// Ideal output:
// INSERT INTO tbl_channel (channel_id, channel_name, network_name) VALUES ('$number', '$name', '$network');
// INSERT INTO tbl_channel_tuner (tuner_class, channel_id, available, group_id) VALUES ('dvb', '$number', 'T', '$nid');
// INSERT INTO tbl_channel_identifier (tuner_class, channel_id, attribute, identifier) VALUES ('dvb', '$number', 'frequency', '$frequency'); -- once per network
// bandwidth?
// INSERT INTO tbl_channel_identifier (tuner_class, channel_id, attribute, identifier) VALUES ('dvb', '$number', 'nid', '$nid'); -- once per network
// INSERT INTO tbl_channel_identifier (tuner_class, channel_id, attribute, identifier) VALUES ('dvb', '$number', 'pid', '$pid');

// compare function for channel numbers
// we need a special hack to make sure that 10 comes before 1
function channel_number($a, $b)
{
	$a = $a['number'];
	$b = $b['number'];
	
	// hack
	if($a == 10) $a = 0;
	if($b == 10) $b = 0;
	// end hack

	if($a == $b) return 0;
	if($a > $b) return 1;
	return -1;
}

foreach($channels as $chan)
{
	$chan = trim($chan);
	if(strlen($chan) == 0)
	{
		continue;
	}
	if($chan[0] == '#')
	{
		continue;
	}
	$chan = explode('|', $chan);

	if($chan[7] > 0)
	{
		if($channel != "")
		{
			if(trim($chan[2]) != $channel)
			{
				continue;
			}
		}
		$bandwidth = trim($chan[5]);
		$frequency = trim($chan[6]);
		$chan = trim($chan[2]);
		echo "\rScanning Channel {$chan} ({$bandwidth}MHz at {$frequency}Hz) ";

		muxy($sock, "set bandwidth $bandwidth");
		muxy($sock, "set frequency $frequency");
		muxy($sock, "zap");
		$timeout = 10;
		while($timeout > 0)
		{
			sleep(1);
			//print_r(muxy($sock, "show zap*"));
			if(show_signal($sock, false) !== false)
			{
				break;
			}
			if($verbose) echo "z";
			$timeout--;
		}
		if(show_signal($sock, false) !== false)
		{
			echo "\n";
			$timeout = 10;
			while($timeout > 0)
			{
				$r = muxy($sock, "show network_name");
				if(isset($r['network_name']))
				{
					$network = $r['network_name'];
					echo "  Found $network...\n";

					// what about channels...
					// some time to load the data
					$p = 0;
					for($x = 0; $x < 10; $x++)
					{
						echo $progress[$p];
						$p++;
						$p %= sizeof($progress) - 1;
						//echo $x;
						sleep(1);
					}
//					echo "\r   \r";
					echo $progress[sizeof($progress) - 1];
					$r = muxy($sock, "show all");
					if($verbose) print_r($r);
					$f = $r['frequency'];
					$b = $r['bandwidth'];
					$nid = $r['network_id'];

					$services = array(); // index by PID
					foreach($r as $k => $v)
					{
						if(strpos($k, 'service_name_') === 0)
						{
							$r = strrpos($k, '_') + 1;
							$pid = substr($k, $r);
							$services[$pid]['name'] = $v;
						}
						if(strpos($k, 'service_type_') === 0)
						{
							$r = strrpos($k, '_') + 1;
							$pid = substr($k, $r);
							$services[$pid]['type'] = $v;
						}
						if(strpos($k, 'service_channel_') === 0)
						{
							$r = strrpos($k, '_') + 1;
							$pid = substr($k, $r);
							$services[$pid]['number'] = $v;
						}
					}
					// print out the summary...
					// sort it?

					uasort($services, 'channel_number');

					$service_count = 0;
					foreach($services as $pid => $v)
					{
						$use = false;
						if(array_key_exists('type', $v))
						{
							if($v['type'] == 'television')
							{
								$use = true;

								if(!array_key_exists('name', $v))
								{
									$v['name'] = $network.' Unknown';
								}
								$name = $v['name'];
								$number = $v['number'];
							}
						}
						else
						{
							// we don't know the type...
							// we must then at least have a name (SBS)
							if(array_key_exists('name', $v))
							{
								$name = strtoupper($v['name']);
								// fiter out RADIO ?
								if(strpos($name, 'RADIO') === false)
								{
									$use = true;
									//$output[] = $v['number'].'|'.$v['name']."|$network|$nid|$pid|$f|$b";
									$name = $v['name'];
									$number = $v['number'];
								}
							}
						}
						if($use)
						{
							$service_count++;

$output2[] = check_set_database("tbl_channel", array("channel_id"), array($number), "channel_name", $name);
$output[] = "INSERT INTO tbl_channel (channel_id, channel_name, network_name) VALUES ('$number', '$name', '$network')";

// If the channel already exists it might have an existing group_id...
if($rescan)
{
	$group = get_group_for_channel($chan);
	echo "Using group $group for channel $chan\n";
}
else
{
	$group = $chan;
}
$output2[] = check_set_database("tbl_channel_tuner", array("tuner_class", "channel_id"), array('dvb', $number), 'available', 'T');
$output2[] = check_set_database("tbl_channel_tuner", array("tuner_class", "channel_id"), array('dvb', $number), 'group_id', $group);
$output[] = "INSERT INTO tbl_channel_tuner (tuner_class, channel_id, available, group_id) VALUES ('dvb', '$number', 'T', '$group')";

if($service_count == 1)
{
	$output2[] = check_set_database("tbl_channel_identifier", array("tuner_class", "channel_id", "attribute"), array('dvb', $number, 'frequency'), 'identifier', $f);
	$output[] = "INSERT INTO tbl_channel_identifier (tuner_class, channel_id, attribute, identifier) VALUES ('dvb', '$number', 'frequency', '$f')";

	$output2[] = check_set_database("tbl_channel_identifier", array("tuner_class", "channel_id", "attribute"), array('dvb', $number, 'bandwidth'), 'identifier', $b);
	$output[] = "INSERT INTO tbl_channel_identifier (tuner_class, channel_id, attribute, identifier) VALUES ('dvb', '$number', 'bandwidth', '$b')";

	$output2[] = check_set_database("tbl_channel_identifier", array("tuner_class", "channel_id", "attribute"), array('dvb', $number, 'nid'), 'identifier', $nid);
	$output[] = "INSERT INTO tbl_channel_identifier (tuner_class, channel_id, attribute, identifier) VALUES ('dvb', '$number', 'nid', '$nid')";
}
$output2[] = check_set_database("tbl_channel_identifier", array("tuner_class", "channel_id", "attribute"), array('dvb', $number, 'pid'), 'identifier', $pid);
$output[] = "INSERT INTO tbl_channel_identifier (tuner_class, channel_id, attribute, identifier) VALUES ('dvb', '$number', 'pid', '$pid')";
						}
					}
					break;
				}
				sleep(1);
				if($verbose) echo "n";
				$timeout--;
			}
		}
	}
}
muxy($sock, "unzap");
echo "\n";

if($rescan)
{
	$output = $output2;
}

if($output_file == "")
{
	foreach($output as $o)
	{
		if(strlen($o) > 0)
		{
			echo "$o;\n";
		}
	}
}
else
{
	$fp = fopen($output_file, 'w');
	foreach($output as $o)
	{
		if(strlen($o) > 0)
		{
			fwrite($fp, "$o;\n");
		}
	}
	fclose($fp);
}

?>
