#!/usr/bin/php -f
<?php
require "../php_lib/lib_orb.php";
require "../php_lib/lib_muxy.php";

$stdin = fopen('php://stdin', 'r');

error_reporting(E_ALL ^ E_NOTICE);

function get_selection($prompt, $options)
{
	global $stdin;

	while(1)
	{
		echo "$prompt";
		$item = fgets($stdin, 1024);
		$item = trim($item);
		//$item = strtolower($item);
		if(in_array($item, $options))
		{
			return $item;
		}
	}
}

function get_string($prompt)
{
	global $stdin;

	echo "$prompt";
	$item = fgets($stdin, 1024);
	$item = trim($item);
	return $item;
}

function config_epg()
{
	global $config;

	if(!isset($config['epg_cache_url']))
	{
		$config['epg_cache_url'] = 'http://www.digital-orb.net/epg/';
	}
	if(!isset($config['epg_region']))
	{
		$config['epg_region'] = '94';
	}

	while(1)
	{
		echo "Digital-Orb will connect to the yahoo EPG using the following settings:\n";
		//echo "1 - Cache URL : {$config['epg_cache_url']}\n";
		echo "1 - Time Zone : {$config['time_zone']}\n";
		echo "2 - Region    : {$config['epg_region']}\n";

		echo "r - Return to main menu\n";

		$selection = get_selection(":", array("1", "2", "r"));

		if($selection == "1")
		{
			//$config['epg_cache_url'] = get_string('New value for EPG cache URL: ');
			$config['time_zone'] = get_string('New value for Time Zone: ');
			date_default_timezone_set($config['time_zone']);
			$tz = @date_default_timezone_get();
			if($tz == $config['time_zone'])
			{
				// OK
			}
			else
			{
				echo "Invalid timezone, using '$tz'\n";
				$config['time_zone'] = $tz;
			}
		}
		else if($selection == "2")
		{
			$config['epg_region'] = get_string('New value for EPG region: ');
		}
		else if($selection == "r")
		{
			return;
		}
	}
}

function scan_epg()
{
	global $orb;

	// should this be a config parameter? - Yes
	if(file_exists("../epg_internet/seven.php"))
	{
		$cmd = "../epg_internet/seven.php";
	}
	else
	{
		$cmd = "../epg/seven.php";
	}
	passthru("$cmd channels");

	// if there are any with identical names, we can pre-fill the data here...
	$sql = "SELECT channel_name FROM tbl_epg_channels";
	$channels = $orb->execute_select_array($sql);
	foreach($channels as $channel)
	{
		$sql = "SELECT channel_id, channel_name FROM tbl_channel";
		$result = $orb->execute_select($sql);
		while($row = $result->fetch_row())
		{
			if(strtoupper($row[1]) == strtoupper($channel))
			{
				// we have a match
				$sql = "REPLACE INTO tbl_channel_identifier (tuner_class, channel_id, attribute, identifier) VALUES ('dvb', '$row[0]', 'yahoo', '$channel')";
				$orb->execute_insert($sql);
			}
		}
	}

	// make sure there is an attribure in the database to get the ball rolling
	$sql = "SELECT COUNT(*) FROM tbl_channel_identifier WHERE tuner_class = 'dvb' AND attribute='yahoo'"; // should this be Yahoo7? - Yes
	$count = $orb->execute_count($sql);
	if($count == 0)
	{
		// we need to kick start the web config by adding an attribute
		$sql = "SELECT channel_id FROM tbl_channel_identifier LIMIT 1"; // any channel will do
		$id = $orb->execute_count($sql); 
		$sql = "INSERT INTO tbl_channel_identifier (tuner_class, channel_id, attribute, identifier) VALUES ('dvb', '$id', 'yahoo', '')";
		$orb->execute_insert($sql);
	}
}

function run_mysql()
{
	global $config;

	$cmd = "mysql '{$config['db_name']}' -u '{$config['db_user']}' --password='{$config['db_pass']}' -h '{$config['db_host']}'";
	echo "$cmd\n";
	system("$cmd < /dev/tty > /dev/tty");
}

function config_database_connection()
{
	global $config;

	while(1)
	{
		echo "Digital-Orb will connect to the mysql database using the following settings:\n";
		echo "1 - Database host     : {$config['db_host']}\n";
		echo "2 - Database name     : {$config['db_name']}\n";
		echo "3 - Database user     : {$config['db_user']}\n";
		echo "4 - Database password : {$config['db_pass']}\n";
		echo "r - Return to main menu\n";

		$selection = get_selection(":", array("1", "2", "3", "4", "5", "r"));

		if($selection == "1")
		{
			$config['db_host'] = get_string('New value for Database host: ');
		}
		else if($selection == "2")
		{
			$config['db_name'] = get_string('New value for Database name: ');
		}
		else if($selection == "3")
		{
			$config['db_user'] = get_string('New value for Database user: ');
		}
		else if($selection == "4")
		{
			$config['db_pass'] = get_string('New value for Database password: ');
		}
		else if($selection == "r")
		{
			return;
		}
	}
}

function save_config()
{
	global $config;

	$fp = fopen('digital_orb.conf', 'w');
	foreach($config as $key => $value)
	{
		fwrite($fp, "$key=$value\n");
	}
	fclose($fp);
}


// update menu. Generic SQL menu?
function check_database_tables()
{
	global $config;

	$tmpfname = tempnam(".", "DUMP");
	$diffname = tempnam(".", "DIFF");
	$dump = "mysqldump -d '{$config['db_name']}' --single-transaction --compatible=mysql323 -u '{$config['db_user']}' --password='{$config['db_pass']}' -h '{$config['db_host']}'";
	passthru("$dump > $tmpfname");
	passthru("../database/mysql-dict ../database/datadict.sql $tmpfname > $diffname");

	sql_save_edit_apply($diffname);
/*	passthru("cat $diffname");

	echo "Do you want to apply the SQL [y/n] ";
	$selection = get_selection(":", array("y", "n"));

	if($selection == "y")
	{
		$cmd = "mysql '{$config['db_name']}' -u '{$config['db_user']}' --password='{$config['db_pass']}' -h '{$config['db_host']}' < $diffname";
		passthru($cmd);
	}

	unlink($diffname);*/
	unlink($tmpfname);
}

function scrub_dvb_cards()
{
	global $orb;

	$sql = "SELECT tuner_id FROM tbl_tuner_instance WHERE tuner_class='dvb'";
	$tids = $orb->execute_select_array($sql);

	echo "Scrubbing details of ".sizeof($tids)." DVB tuners\n";

	foreach($tids as $tid)
	{
		$sql = "DELETE FROM tbl_tuner_details WHERE tuner_id='$tid'";
		$orb->execute_insert($sql);

		$sql = "DELETE FROM tbl_tuner_instance WHERE tuner_id='$tid'";
		$orb->execute_insert($sql);
	}

	echo "You should remove any dvb*.init files manually\n";

}

function config_dvb_cards()
{
	global $orb;
	global $muxy_sockets;

	// check some database things
	$sql = "SELECT COUNT(*) FROM tbl_tuner_class WHERE tuner_class = 'dvb'";
	if($orb->execute_count($sql) != 1)
	{
		$sql = "INSERT INTO tbl_tuner_class (tuner_class, description) VALUES ('dvb', 'Linux DVB Driver (muxy)')";
		$orb->execute_insert($sql);
	}

	// there are 3 parts to this
	// the /dev device path
	// the muxy config which maps this to a socket
	// the database entry for the socket

	$frontend_maps = array();
	$socket_maps = array();

	exec('ls /dev/dvb/adapter*/frontend*', $dev);
	echo "I found ".sizeof($dev)." dvb adapters in /dev/dvb\n";

	$sql = "SELECT tuner_id, 
		       description 
		FROM   tbl_tuner_instance 
		WHERE  tuner_class='dvb'";
	$tuner = array();
	$result = $orb->execute_select($sql);
	while($row = $result->fetch_row())
	{
		$tuner[$row[0]] = $row[1];
	}
	echo "I found ".sizeof($tuner)." dvb adapters listed in the database\n";
	
	$sql = "SELECT tuner_id,
	               sock_location
	        FROM   tbl_tuner_details";

	$db = array();
	$result = $orb->execute_select($sql);
	while($row = $result->fetch_row())
	{
		$db[] = $row[1];
	}

	echo "I found ".sizeof($db)." adapters configured in the database\n";

	// check for muxy mappings
	exec('ls dvb*.init', $muxy);
	echo "I found ".sizeof($muxy)." mappings\n";

	foreach($muxy as $mapping)
	{
		$map = file($mapping);
		// search the map for the 'set frontend' and 'set socket'
		$frontend = '';
		$socket = '';
		foreach($map as $line)
		{
			$line = trim($line);
			//echo "-$line-\n";
			if(preg_match('/^set frontend (.*)$/', $line, $matches))
			{
				$frontend = $matches[1];
			}
			if(preg_match('/^set socket (.*)$/', $line, $matches))
			{
				$socket = $matches[1];
			}
		}
		echo "Mapping $frontend <-> $socket\n";
		$frontend_maps[$frontend] = $socket;
		$socket_maps[$socket] = $frontend;
	}

	// check of which frontends are mapped
	foreach($dev as $id => $frontend)
	{
		if(in_array($frontend, $socket_maps))
		{
			// Good, what is the socket name?
			foreach($socket_maps as $socket => $fe)
			{
				if($fe == $frontend)
				{
					break;
				}
			}
		}
		else
		{
			echo "There is no mapping for device $frontend (id $id)\n";
			// do we need to add to the database?
			echo "Do we need to add it to the database?\n";

			// which socket name should we use?
			$socket = "/tmp/video/dvb$id.sock";

			if(!in_array($socket, $db))
			{
				$sql = "INSERT INTO tbl_tuner_details (sock_location) VALUES ('$socket')";
				$orb->execute_insert($sql);
				echo "$sql;\n";
			
			}
			// or just create the .init file?
			$demux = str_replace('frontend', 'demux', $frontend);
			$dvr = str_replace('frontend', 'dvr', $frontend);
			$init = "log dvb$id.log
set country AUS
set region VIC
set frontend $frontend
set demux $demux
set dvr $dvr
set bandwidth 7
set socket $socket
listen
";
			echo $init;
			file_put_contents("dvb$id.init", $init);
		}
		$sql = "SELECT tuner_id FROM tbl_tuner_details WHERE sock_location='$socket'";
		$tid = $orb->execute_count($sql);
		if($tid == "")
		{
			echo "No tuner in database which uses socket $socket\n";
			$sql = "INSERT INTO tbl_tuner_details (sock_location) VALUES ('$socket')";
			echo "$sql;\n";
			$orb->execute_insert($sql);
			$sql = "SELECT tuner_id FROM tbl_tuner_details WHERE sock_location='$socket'";
			$tid = $orb->execute_count($sql);
			echo "Added tuner $tid\n";
		}

		if(!array_key_exists($tid, $tuner))
		{
			$sql = "DELETE FROM tbl_tuner_instance WHERE tuner_id='$tid'";
			$orb->execute_insert($sql);
			$sql = "INSERT INTO tbl_tuner_instance(tuner_id, tuner_class, description) VALUES('$tid', 'dvb', 'Digital Tuner #$tid')";
			echo "$sql\n";
			$orb->execute_insert($sql);
		}
	}

	// check which database entries are mapped
	foreach($db as $socket)
	{
		if(in_array($socket, $frontend_maps))
		{
			// good
		}
		else
		{
			echo "There is no mapping for socket $socket\n";
			// do we need to delete the database entry?
			// or add the muxy .init file?
		}
	}

	// start up the tuners and get the card details
	exec('./start.sh tuner > /dev/null');
	sleep(5);

	$sql = "SELECT tuner_id FROM tbl_tuner_instance WHERE tuner_class='dvb'";
	$tids = $orb->execute_select_array($sql);

	// disconnect any old muxy connections...
	$muxy_sockets = array(); // should make a function

	foreach($tids as $tid)
	{
		$sql = "SELECT sock_location
		        FROM   tbl_tuner_details
			WHERE  tuner_id='$tid'";
		$socket = $orb->execute_count($sql);
		echo "Identifying socket $socket -";

		// we need a timeout for the connect.... I don't know how to do that in PHP
		if(file_exists($socket))
		{
			$r = muxy($socket, "identify");
			$r = muxy($socket, "show all");
			$card = "{$r['card']} ({$r['type']})";
			echo " $card\n";
			$sql = "REPLACE INTO tbl_tuner_instance(tuner_id, tuner_class, description) VALUES('$tid', 'dvb', 'Digital Tuner #$tid - $card')";
			$orb->execute_insert($sql);
			$r = muxy($socket, "exit");
		}
		else
		{
			echo "No socket at $socket\n";
		}
	}
}

function scan_channels()
{
	global $config;
	global $orb;

	$sql = "SELECT tuner_id, 
		       description 
		FROM   tbl_tuner_instance 
		WHERE  tuner_class='dvb'";
	$tuner = array();
	$result = $orb->execute_select($sql);
	while($row = $result->fetch_row())
	{
		$tuner[$row[0]] = $row[1];
	}
	if(sizeof($tuner) == 0)
	{
		echo "No tuners configured\n";
		return;
	}
	else if(sizeof($tuner) == 1)
	{
		// there is no choice
		$id = each($tuner);
		$id = $id['key'];
	}
	else
	{
		echo "Select a tuner to use for scanning:\n";
		// we need a menu
		$options = array();
		foreach($tuner as $key => $value)
		{
			echo "$key - $value\n";
			$options[] = $key;
		}
		echo "c - cancel\n";
		$options[] = "c";
		$id = get_selection(":", $options);
	}
	if($id == "c")
	{
		return;
	}
	echo "Using tuner $id\n";
	$sql = "SELECT sock_location
	        FROM   tbl_tuner_details
		WHERE  tuner_id='$id'";
	$socket = $orb->execute_count($sql);
	echo "Using socket $socket\n";

	while(true)
	{
		exec("ls /usr/share/doc/muxy-*/AUS", $channel);
		$channel = trim($channel[0]);

		$c = get_string("Channel file [$channel]: ");
		if($c != "")
		{
			$channel = $c;
		}
		if(file_exists($channel))
		{
			break;
		}
		else
		{
			echo "File $channel does not exist\n";
		}
	}

	
//	$channel = "MtDandenong";

	// full scan or rescan (update)
	echo "1 - Full Scan\n";
	echo "2 - Rescan for changes\n";

	echo "c - cancel\n";

	$selection = get_selection(":", array("1", "2", "c"));
	if($selection == 'c')
	{
		return;
	}
	else if($selection == 1)
	{
		$rescan = "";
	}
	else
	{
		$rescan = "rescan";
	}


	$tmpfile = tempnam("/tmp", "muxy");

	exec('./start.sh tuner > /dev/null');
	sleep(5);
	$cmd = "./dvb_scan.php socket $socket file $channel output $tmpfile $rescan";
	echo "Running $cmd\n";
	passthru($cmd);

	sql_save_edit_apply($tmpfile);
}

function sql_save_edit_apply($tmpfile)
{
	global $config;

	while(true)
	{
		passthru("cat $tmpfile");

		echo "s - Save SQL\n";
		echo "e - Edit SQL\n";
		echo "a - Apply SQL\n";
		echo "r - Return to main menu\n";
		$selection = get_selection(":", array("s", "e", "a", "r"));

		if($selection == "a")
		{
			$cmd = "mysql '{$config['db_name']}' -u '{$config['db_user']}' --password='{$config['db_pass']}' -h '{$config['db_host']}' < $tmpfile";
			passthru($cmd);
			echo "Done\n";
		}
		else if($selection == "e")
		{
			$visual = $_ENV['EDITOR'];
			if(!file_exists($visual))
			{
				$visual = "vi";
			}
			$cmd = "$visual $tmpfile";
			system("$cmd < /dev/tty > /dev/tty");
		}
		else
		{
			unlink($tmpfile);
			return;
		}
	}
}

echo "Digital ORB Setup\n";
echo "=================\n";

// create config file
load_config();

while(1)
{
	echo "1 - Configure database connection settings\n";
	echo "2 - Check database connection\n";
	echo "3 - Check database tables\n";
	echo "4 - Configure DVB cards\n";
	echo "4b- Scrub DVB card configuration\n";
	echo "5 - Scan for channels\n";
	echo "6 - Configure EPG\n";
	echo "7 - Scan EPG for channels\n";
	echo "s - Save config file\n";
	echo "d - Run mysql\n";
	echo "q - Quit\n";
	
	$selection = get_selection(":", array("1", "2", "3", "4", "4b", "5", "6", "7", "s", "d", "q"));
	
	if($selection == "1")
	{
		config_database_connection();
	}
	else if($selection == "2")
	{
		$db_setup = true;
		load_database();
		if($orb->connected)
		{
			echo "Connected to database OK\n";
		}
		else
		{
			echo "{$orb->error}\n";
		}
		$db_setup = false;
	}
	else if($selection == "3")
	{
		$db_setup = true;
		load_database();
		if($orb->connected)
		{
			check_database_tables();
		}
		else
		{
			echo "{$orb->error}\n";
		}
		$db_setup = false;
	}
	else if($selection == "4")
	{
		load_database();
		config_dvb_cards();
	}
	else if($selection == "4b")
	{
		load_database();
		scrub_dvb_cards();
	}
	else if($selection == "5")
	{
		load_database();
		scan_channels();
	}
	else if($selection == "6")
	{
		config_epg();
	}
	else if($selection == "7")
	{
		load_database();
		scan_epg();
	}
	else if($selection == "s")
	{
		save_config();
	}
	else if($selection == "d")
	{
		run_mysql();
	}
	else if($selection == "q")
	{
		return;
	}
}
?>
