#!/usr/bin/php -f
<?php
require "../php_lib/lib_orb.php";

load_database();
//load_libs(array("lib_dbedit.php", "lib_dynamic.php"));

$sql1 = "SELECT   epg_id, 
                 channel_id, 
	         start_time, 
	         end_time, 
	         title, 
	         sub_title, 
	         description, 
	         details, 
	         data_source, 
	         data_source_id 
	FROM     tbl_epg_program 
	WHERE    end_time > NOW() 
	ORDER BY start_time, 
	         channel_id";


$simulcast = "SELECT   COUNT(channel_id) AS n, 
                       start_time, 
		       end_time, 
		       title 
	      FROM     tbl_epg_program 
	      WHERE    end_time > NOW() 
	      GROUP BY title, 
	               start_time, 
		       end_time 
	      HAVING   n > 1 
	      ORDER BY start_time";

$rules = array();
/*
$rules[] = "^Heroes$";
$rules[] = "The 7.30 Report";
$rules[] = "Catalyst";
$rules[] = "Spicks & Specks";
//$rules[] = "The Chaser's War on Everything";
//$rules[] = "Prison Break";
$rules[] = "Media Watch";
$rules[] = "A1 Grand Prix";
$rules[] = "A1GP";
$rules[] = "STAR TREK";
$rules[] = "Champ Car World Series";
$rules[] = "^Oz$";
$rules[] = "V8 Supercars";
//$rules[] = "Bad Boy Racers";
$rules[] = "The Shield";
$rules[] = "Terminator";*/
/*$rules[] = "The Wire";
$rules[] = "Futurama";
$rules[] = "Iron Chef";
$rules[] = "Packed to the Rafters";
$rules[] = "The Big Bang Theory";
$rules[] = "2010 FIFA World Cup$";
$rules[] = "Vampire Diaries$";*/
//$rules[] = "Top Gear";
//$rules[] = "Mythbusters";
$rules[] = "Law & Order";
$rules[] = "NASCAR";
$rules[] = "Dakar Rally";
$rules[] = "ABC News$||2";
$rules[] = "Zumbo";
$rules[] = "Heston";
$rules[] = "Masterchef";
$rules[] = "Formula One";
$rules[] = "Formula 1";
//$rules[] = "Sabrina, the Teenage Witch";
//$rules[] = "wonders of";
//$rules[] = "^Friends$";
//$rules[] = "Jonathan Creek";
$rules[] = "Offspring";
$rules[] = "Wonderland";
$rules[] = "A-League";
//$rules[] = "Winners & Losers";
//$rules[] = "Mega";
//$rules[] = "Toughest Fixes";
//$rules[] = "Glee";

/* rule format
 * |Title|Sub-title|Channel|Simulcast|Repeat|
 *
 * Title is a regex which may have anchors. These need to be tweeked into .* because the | will act as
 * anchors
 * Sub title = same as title
 * Channel = same as title? Should we use name, number, ID or both?
 * Simulcast code is calculated when the same program is on at the same time on multiple
 * channels. Possible values are: - Not simulcast ? or do we always need a code?
 *                                A This is the Analogue instance
 *                                D This is the Digital Standard Def instance
 *                                H This is the Digital High Def instance
 *                                S This is the Second or more instance of any of the above
 * * Record all instances
 * A Record on analog only
 * D Record on digital SD only
 * H Record on digital HD only
 *
 * Repeat code is calculated when the same program is on at multiple times in the past n hours
 * n is the time in which the program should not have already been recorded. (is this safe or will
 * we lock into recording the repeat all the time?)
 */

$simulcast_index = array();
$result = $orb->execute_select($simulcast);
while($row = $result->fetch_row())
{
	$key = $row[1].$row[2].$row[3];
	$simulcast_index[$key] = $row[0];
}

$sql = "SELECT rule FROM tbl_auto_schedule WHERE active='T' ORDER BY sid";
$result = $orb->execute_select($sql);
while($row = $result->fetch_assoc())
{
	$rules[] = $row['rule'];
}

$simulcast_ignore = array(1, 20, 30, 70, 90);

$result = $orb->execute_select($sql1);
while($row = $result->fetch_assoc())
{
	$id = "{$row['data_source']}-{$row['data_source_id']}";
	$status = get_recording_status($id);

	$simulcast = 0;
	$key = $row['start_time'].$row['end_time'].$row['title'];
	if(array_key_exists($key, $simulcast_index))
	{
		//echo "{$row['title']} is simulcast on channel {$row['channel_id']}";
		// we need to convert the channel_id into some kind of code
		// what if the choice is between analog & HD?
		// we can have codes to ignore and remove from the index once applied?

		if(in_array($row['channel_id'], $simulcast_ignore))
		{
			$simulcast = 2;
			//echo " ignoring\n";
			//continue;
		}
		else
		{
			$simulcast = 1;
			//echo "\n";
		}
	}

	foreach($rules as $ruleset)
	{
		$rule = explode('|', $ruleset);
		$title = $rule[0];
		if(preg_match("/$title/i", $row['title']))
		{
			if(array_key_exists(2, $rule))
			{
				if($row['channel_id'] != $rule[2])
				{
					echo "{$row['title']} $status is on channel {$row['channel_id']} and not $rule[2]\n";
					continue;
					
				}
			}
			echo "Match on {$row['title']} $status on channel {$row['channel_id']}\n";
			if($status == "")
			{
				if($simulcast > 1)
				{
					// we don't want to record this instance
					echo "Skipping simulcast of {$row['title']} on channel {$row['channel_id']}\n";
				}
				else
				{
					// activate recording this id
					if($row['title'] == "The Shield")
					{
						enable_record_program($id, 5, 30);
					}
					else if($row['title'] == "2010 FIFA World Cup")
					{
						enable_record_program($id, 5, 45);
					}
					if($row['title'] == "The Big Bang Theory")
					{
						enable_record_program($id, 15, 10);
					}
					else
					{
						enable_record_program($id);
					}
				}
			}
			else
			{
				echo "status is already $status\n";
			}
		}
		else
		{
			// we don't care
		}
	}
}

?>
