<?php
	/*
	 * These are the database functions.  The first set of functions are generic database
	 * abstractions.
	 *
	 * The second set are specific to the esp3 database
	 */

$db_selects = 0;
$db_queries = 0;
$db_setup = 0; // allow conections to fail
$csg_sql_log = false; // SQL logging

class Result
{
	var $database;
	var $result;

	function Result($database, $result)
	{
		$this->datebase = $database;
		$this->result = $result;
	}

	function free()
	{
		return mysql_free_result($this->result);
	}

	function fetch_row()
	{
		return mysql_fetch_row($this->result);
	}

	function fetch_row_array()
	{
		return mysql_fetch_array($this->result);
	}

	function fetch_field_names($extra = "")
	{
		$r = array();
		for($i = 0; $i < mysql_num_fields($this->result); $i++)
		{
			array_push($r, mysql_field_name($this->result, $i));
		}
		if(is_array($extra))
		{
			$r = array_merge($r, $extra);
		}
		return $r;
	}

	function fetch_fields()
	{
		$r = array();
		for($i = 0; $i < mysql_num_fields($this->result); $i++)
		{
			array_push($r, mysql_fetch_field($this->result, $i));
		}
		return $r;
	}

	/* This probably belongs in lib_dbedit but it is here for now...
	 */
	function fetch_field_names_sort($extra = "", $sort_prefix = "sort")
	{
		$php_self = $_SERVER['PHP_SELF'];
		$query    = $_SERVER['QUERY_STRING'];
		if(strlen($query) > 0)
		{
			// see if there is already a '$sort_prefix='
			$pos = strpos($query, "$sort_prefix=");
			if($pos !== false)
			{
				// lets hope that it is on the end of the query for now
				$query = substr($query, 0, $pos - 1);
			}
		}


		// check again in case we modified the query string
		if(strlen($query) > 0)
		{
			// we also need to re-escape any & already in the query string...
			$query = strtr($query, array('&' => '&amp;'));
			$query = "?$query&amp;$sort_prefix=";
		}
		else
		{
			$query = "?$sort_prefix=";
		}

		$r = array();
		for($i = 0; $i < mysql_num_fields($this->result); $i++)
		{
			$name = mysql_field_name($this->result, $i);
			$url = "$php_self$query$name";
			if($_GET[$sort_prefix] == $name && $_GET[$sort_prefix."dir"] != "dec")
			{
				$url.= "&amp;$sort_prefix"."dir=dec";
			}
			else
			{
				$url.= "&amp;$sort_prefix"."dir=asc";
			}
			$color = "#FFFFFF"; // we need to get this from somewhere...?
			//$s = "<a href=\"$url\" style=\"color: $color\">$name</a>";
			$s = "<a href=\"$url\">$name</a>";
			array_push($r, $s);
		}
		if(is_array($extra))
		{
			$r = array_merge($r, $extra);
		}
		return $r;
	}

	function num_rows()
	{
		return mysql_num_rows($this->result);
	}
	
	function fetch_assoc()
	{
		return mysql_fetch_assoc($this->result);
	}

	function fetch()
	{
		return mysql_fetch_assoc($this->result);
	}
}

class Database
{
	var $dbhost;
	var $dbname;
	var $dbuser;
	var $dbpass;

	var $db;
	var $connected = false;
	var $error;

	var $sql_time_start;

	function Database($dbhost, $dbname, $dbuser, $dbpass)
	{
		$this->connect($dbhost, $dbname, $dbuser, $dbpass);
	}

	function connect($dbhost, $dbname, $dbuser, $dbpass)
	{
		global $db_setup;

		$this->dbhost = $dbhost;
		$this->dbname = $dbname;
		$this->dbuser = $dbuser;
		$this->dbpass = $dbpass;

		$this->db = @mysql_pconnect($dbhost, $dbuser, $dbpass);
	        if($this->db === false)
	        {
			$this->error = "mysql connect error: ".mysql_error()."(".mysql_errno().")\n";
			if($db_setup)
			{
				return;
			}
			echo $this->error;
			die;
		}

		if(!mysql_select_db($dbname, $this->db))
		{
			$this->error = "mysql error: ".mysql_error($this->db)."(".mysql_errno($this->db).")";
			if($db_setup)
			{
				return;
			}
			echo "Error connecting to database";
			die;
		}
		$this->connected = true;
	}


	/*
	 * Database helper functions
	 */

	function getmicrotime()
	{
		list($usec, $sec) = explode(" ", microtime());
		return ((float)$usec + (float)$sec);
	}

	function sql_log_start()
	{
		global $csg_sql_log;

		if($csg_sql_log)
		{
			$this->sql_time_start = $this->getmicrotime();
		}
	}

	function sql_log($sql)
	{
		// open the log file...
		global $sql_log_file, $csg_sql_log;

		if($csg_sql_log)
		{
			if(!isset($sql_log_file))
			{
				$sql_log_file = @fopen("/tmp/csg-sql.log", "a");
			}
			@fwrite($sql_log_file, $sql.";\n");

			$sql_time_stop = $this->getmicrotime();
			$duration = number_format(($sql_time_stop - $this->sql_time_start) * 1000, 3);
			@fwrite($sql_log_file, "($duration ms)\n");
		}
	}

	function execute_select($sql)
	{
		global $db_selects, $db_queries;

		if(strpos(strtoupper($sql), "SELECT *") !== false)
		{
			add_warning("SELECT * used in '$sql'");
		}

		$this->sql_log_start();
        $result = mysql_query($sql, $this->db);
        if(mysql_error($this->db))
        {
		$error_message = "mysql error: ".mysql_error($this->db)."(".mysql_errno($this->db).")\nSQL was $sql";
                //echo "Error: ".mysql_error($this->db)."(".mysql_errno($this->db).")\n";
		//		echo "<br>SQL was ".$sql;
                mysql_query("UNLOCK TABLES", $this->db);
		trigger_error($error_message, E_USER_ERROR);
                die;
                return false;
        }
        else
        {
				$db_selects++;
				$db_queries++;
				$this->sql_log($sql);
                return new Result($this, $result);
        }
	}

	function execute_insert($sql)
	{
		global $db_selects, $db_queries;

		$this->sql_log_start();
        $result = mysql_query($sql, $this->db);
        if(mysql_error($this->db))
        {
		$error_message = "mysql error: ".mysql_error($this->db)."(".mysql_errno($this->db).")\nSQL was $sql";
                //echo "Error: ".mysql_error($this->db)."(".mysql_errno($this->db).")\n";
                mysql_query("UNLOCK TABLES", $this->db);
		//		echo "<br>SQL was ".$sql;
		trigger_error($error_message, E_USER_ERROR);
                die;
                return false;
        }
        else
        {
				$db_queries++;
				$this->sql_log($sql);
                return true;
        }
	}


	function execute_count($sql)
	{
		$result = $this->execute_select($sql);
        $row = $result->fetch_row();
		$result->free();
        return $row[0];
	}

	function execute_select_array($sql)
	{
		$r = array();
		$result = $this->execute_select($sql);
		while($row = $result->fetch_row())
		{
			array_push($r, $row[0]);
		}
		$result->free();
        return $r;
		
	}

	function get_inserted_id()
	{
		$sql = "SELECT LAST_INSERT_ID()";
		return $this->execute_count($sql);
	}

	function affected_rows()
	{
		return mysql_affected_rows($this->db);
	}

	function get_field_info($table, $field)
	{
		$result = mysql_list_fields($this->dbname, $table, $this->db);

		for($i = 0; $i < mysql_num_fields($result); $i++)
		{
			$f = mysql_field_name($result, $i);
			if($f == $field)
			{
				$field_type = mysql_field_type($result, $i);
				$field_len = mysql_field_len($result, $i);

				// if this is a string it might be an enum...
				if($field_type == "string")
				{
					$flags = mysql_field_flags($result, $i);
					if(strstr($flags, "enum"))
					{
						$field_type = "enum";
					}
					//echo $flags;
				}
				$r = array($field_type, $field_len);
				break;
			}
		}

		mysql_free_result($result);

		return $r;
	}

	function get_enum_values($table, $field)
	{
		$sql = "SHOW COLUMNS FROM $table LIKE '$field'";
		$values = "";

		$result = $this->execute_select($sql);
		if($row = $result->fetch_row())
		{
		 	$enum = $row[1]; // enum('Y','N')

			// remove the enum() bits
			$enum = substr($enum, 5, -1);

			// split into an array
			$values = explode(',', $enum);
			for($i = 0; $i < sizeof($values); $i++)
			{
				// remove the '' around the string
				$values[$i] = substr($values[$i], 1, -1);
			}
		}
		$result->free();

		return $values;
	}

	function dbescape($s)
	{
		//return strtr($s, array("\\\\" => "\\\\", "\\'" => "\\'", "'" => "\\'"));
		return mysql_real_escape_string($s, $this->db);
	}
}

?>
