<?php

$muxy_sockets = array();

$muxy_default = "muxy0.sock";
//$muxy_default = "/home/rshaw/fyproject/muxy-0.7/muxy0.sock";

function muxy_connect($path)
{
	global $muxy_sockets;
	$tries = 5;

	$s = socket_create(AF_UNIX, SOCK_STREAM, 0);
	while($tries > 0)
	{
		if(@socket_connect($s, $path))
		{
			$muxy_sockets[$path] = $s;
			break;
		}
		sleep(1);
	}
}

// muxy_connect($muxy_default);
// muxy_connect($my_muxy);

function muxy($path, $cmd, $read_result = true)
{
	global $muxy_sockets;

//echo "MUXY: $path : $cmd\n";

	if(!isset($muxy_sockets[$path]))
	{
		muxy_connect($path);
	}

	$s = $muxy_sockets[$path];

	$results = array();

	if(@socket_write($s, $cmd."\n") === FALSE)
	{
		socket_close($muxy_sockets[$path]);
		echo "Reconnecting to $path\n";
		// try and reconnect
		$muxy_sockets[$path] = muxy_connect($path);
		$s = $muxy_sockets[$path];
		socket_write($s, $cmd."\n");
	}

	// read data until we get "END\n"

	while($read_result)
	{
		$r = trim(@socket_read($s, 1024, PHP_NORMAL_READ));
		//echo "-$r-\n";
		if($r == "")
		{
			break;
		}
		if($r == "END")
		{
			break;
		}
		if($r[0] == ':')
		{
			// correct format result
			$n = strpos($r, '=');
			if($n < 2)
			{
				$results[] = substr($r, 1);
			}
			else
			{
				$key = substr($r, 1, $n - 1);
				$value = substr($r, $n + 1);

				$results[$key] = $value;
			}
		}
	}

	return $results;
}

function show_signal($path, $print = true)
{
	$r = muxy($path, "show zap*");

	if(isset($r['zap_locked']) && $r['zap_locked'] == "yes")
	{
		$strength = floor($r['zap_signal_strength'] * 100 / 65536);
		$ratio    = floor($r['zap_signal_noise_ratio'] * 100 / 65536);

		$msg = "Signal Strength $strength% SNR $ratio%\n";
		if($print)
		{
			echo $msg;
		}
		return $msg;
	}
	else
	{
		return false;
	}
}

?>
