<?php

require "../php_lib/lib_orb.php";

load_database();

function file_put_to_cache($filename, $string)
{
	$string = base64_encode($string);
	$url = "http://uranus.it.swin.edu.au/~jnewbigin/epg/?key=$filename&data=$string";
	//echo "Cache save $url\n";
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_URL, $url);
	$result = curl_exec($ch);

	if (curl_errno($ch)) 
	{
      		print curl_error($ch);
		$result = "";
	}
	else
	{
		if(curl_getinfo($ch, CURLINFO_HTTP_CODE) != 200)
		{
			$result = "";
		}
	}
	curl_close($ch);
}

function load_cache($filename)
{
	$url = "http://uranus.it.swin.edu.au/~jnewbigin/epg/?key=$filename&date=true";
	//echo "Cache load $url\n";
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_URL, $url);
	$result = curl_exec($ch);

	if (curl_errno($ch)) 
	{
      		print curl_error($ch);
		$result = "";
	}
	else
	{
		if(curl_getinfo($ch, CURLINFO_HTTP_CODE) != 200)
		{
			$result = "";
		}
	}
	curl_close($ch);

	return $result;
}

function touch_cache($filename)
{
	$url = "http://uranus.it.swin.edu.au/~jnewbigin/epg/?key=$filename&validate=true";
	//echo "Cache load $url\n";
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_URL, $url);
	$result = curl_exec($ch);

	if (curl_errno($ch)) 
	{
      		print curl_error($ch);
		$result = "";
	}
	else
	{
		if(curl_getinfo($ch, CURLINFO_HTTP_CODE) != 200)
		{
			$result = "";
		}
	}
	curl_close($ch);

	return $result;
}

function extract_id($result)
{
	preg_match_all("/rel=\"\d+-\d-(\d+)\"/", $result, $id);
	return implode(",", $id[1]);
}

function unstore_program($id)
{
	global $orb;

	disable_record_program($id);

	$sql = "DELETE FROM tbl_epg_program WHERE data_source='Yahoo7' AND data_source_id='$id'";
	echo "$sql\n";
	$orb->execute_select($sql);
}


	function load_listing($start_time)
	{
		$region   = 94; // Melbourne
		$next = $start_time;

		$t = time();
		$hour  = date("H", $t);
		$min   = date("i", $t);
		$date  = date("d", $t);
		$month = date("m", $t);
		$year  = date("Y", $t);

		$url = "http://au.tv.yahoo.com/tv-guide/?hour=$hour&min=$min&date=$date&mon=$month&year=$year&tvrg=$region&next=$next";

		echo "Loading $url\n";
		// sleep so we don't pound the server and get kicked off
//		sleep($delay);

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_URL, $url);
		$result = curl_exec($ch);
	
		if(curl_getinfo($ch, CURLINFO_HTTP_CODE) != 200)
		{
	      		echo $result."\n";
			$result = "";
		}
		else
		{
			// save the results to the cache...
			$result = extract_id($result);
		}
		curl_close($ch);
		return $result;
	}
	
	function load_yahoo_id($id)
	{
		global $agent;

		$url = "http://au.tv.yahoo.com/tv-guide/broker.html?event_id=$id";

		{
			echo "Loading $url\n";
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_USERAGENT, $agent);
			// referer
			$result = curl_exec($ch);

			if(curl_getinfo($ch, CURLINFO_HTTP_CODE) != 200)
			{
		      		echo curl_getinfo($ch, CURLINFO_HTTP_CODE)." ".$result."\n";
			}
			else
			{
				// save the results to the cache...
				if(preg_match('/error 999/', $result))
				{
					echo "Download rejected\n";
					$result = "";
				}
				else
				{
				//	file_put_to_cache($filename, $result);
				}
			}
			curl_close($ch);
		}

		if($result == "")
		{
			return;
		}
		return $result;
	}

	function decode_yahoo_id($id, $result)
	{

		// parse the new format data...

		// 0  = start
		// 1  = key
		// 11 = key string
		// 2  = value
		// 21 = value string
		// 22 = \ escape
		// 9  = end

		$key = "";
		$value = "";
		$state = 0; // start
		$data = array();

		for($i = 0; $i < strlen($result); $i++)
		{
			$c = $result[$i];

			if($state == 0)
			{
				if($c == "{")
				{
					$state = 1;
				}
			}
			else if($state == 1)
			{
				if($c == ':')
				{
					$state = 2;
				}
				else if($c == '"')
				{
					$state = 11;
				}
				else
				{
					$key.= $c;
				}
			}
			else if($state == 11)
			{
				if($c == '"')
				{
					$state = 1;
				}
				else
				{
					$key.= $c;
				}
			}
			else if($state == 2)
			{
				if($c == ',')
				{
					$data[$key] = $value;
					$key = "";
					$value = "";
					$state = 1;
				}
				else if($c == '}')
				{
					$data[$key] = $value;
					$state = 9;
				}
				else if($c == '"')
				{
					$state = 21;
				}
				else
				{
					$value.= $c;
				}
			}
			else if($state == 21)
			{
				if($c == '"')
				{
					$state = 2;
				}
				else if($c == "\\")
				{
					$state = 22;
				}
				else
				{
					$value.= $c;
				}
			}
			else if($state == 22)
			{
				if($c == "/")
				{
					$value.= $c;
					$state = 21;
				}
				else if($c == '"')
				{
					$value.= $c;
					$state = 21;
				}
				else
				{
					// unknown escape
					$value.= "\\$c";
					$state = 21;
				}
			}
		}
	//	print_r($data);

		if(!array_key_exists('channel', $data))
		{
			return;
		}

		$channel     = $data['channel'];
		if($channel == 'null')
		{
			echo "No program $id\n";
			return false;
		}
		else
		{
			$title       = $data['title'];
			$subtitle    = "";
			$category    = $data['genre'];
			$description = $data['description'];

		
			$start_date = date("Y-m-d H:i", $data['start_date']);
			$end_date   = date("Y-m-d H:i", $data['end_date']);
			//echo "program($id, $channel, $start_date, $end_date, $title, $subtitle, $category, $description)\n";
			return array($id, $channel, $start_date, $end_date, $title, $subtitle, $category, $description);
		}
	}

?>
