#!/usr/bin/php -f
<?php

require "../php_lib/lib_orb.php";

load_libs(array("lib_muxy.php"));
load_database();


/*
  Database tables used:
  - tbl_schedule_details - Information about what to record. When (start & stop) and where (channel_id)

  - tbl_recording_details - Information about what is currently recording (tuner, slot)
                          - should use auto_increment

  - tbl_tuner_details - current state of tuners
                      - we need a list of available tuners, can the state be kept in memory?

  - tbl_channel_identifier - get the frequency for (channel_id)


- tuners are fixed. (they might go online & offline while we are running?)
- programs can come and go
- the recordings must identify a channel
- Logical Channel Number (LCN)  (These can and do change)
- Channel Name 'ABC1', 'TEN HD', 'Nine' (These can and do change)
- NID - This should not change
- PID - This can change but does not seem to

What is the 'best' unique ID?
- should be robust agains re-scanning channels


This scheduler is for tuner_class 'dvb'.

*/


//directory that the recordings are stored

// config file? database?

$video_dir = "/tmp/video/";

if(!file_exists($video_dir))
{
   echo "Directory $video_dir does not exist.  Create it and try again\n";
   die;
}


$muxy_socket = array();


//run this command when scheduler is started.  It will update the details of the DB incase of a crash.
function muxy_status()
{
	global $orb;
	global $muxy_socket;

	$num_values = count($muxy_socket);
	
	foreach($muxy_socket as $i => $socket)
	{
		$r = muxy($muxy_socket[$i], "show all");
		
		if(isset($r['frequency']))
		{
			$frequency = $r['frequency'];
		}
		else
		{
			$frequency = 0;
		}
		if(isset($r['network_id']))
		{
			$network_id = $r['network_id'];
		}
		else
		{
			$network_id = "0x0000";
		}
		//get number of open slots
		
		$num_slots = 0;
		
		for($j = 0; $j < 8; $j++)
		{
			//if($r["slot_$j"] != "")
			if(isset($r["slot_$j"]))
			{
				$num_slots++;
			}			
		}
		//$slot0 = $r['slot_0'];
		//$slot1 = $r['slot_1'];
		//$zap_sig = $r['zap_signal'];		
		/*
		echo "tuner $i \n";
		echo "- frequency  = $frequency\n";
		echo "- network_id = $network_id\n";
		echo "- open slots = $num_slots\n";
		*/
		if($num_slots == 0)
		{
			$sql="UPDATE tbl_tuner_details
 			      SET    frequency = '0',
			 	     status = 'idle',
				     slots_open = '0'
 			      WHERE  tuner_ID = '$i'";	
		
			$orb->execute_insert($sql);
		}
		else
		{
			$sql="UPDATE tbl_tuner_details
                              SET    frequency = '$frequency',
                                     status = 'recording',
                                     slots_open = '$num_slots'
                              WHERE  tuner_ID = '$i'";
			
			$orb->execute_insert($sql);
		}	
	//	echo "number of open slots = $num_slots\n";
	//	echo "muxy_status tuner $i slot0 = $slot0\n";
	//	echo "muxy_status tuner $i slot1 = $slot1\n";
	//	echo "muxy_status tuner $i frequency = $frequency\n";
	//	echo "muxy_status tuner $i zap_signal = $zap_sig\n";	

		// what about programs which are/should be recording...

		// get a list from the database of 'recording'
		// and which match an open slot are OK, otherwise set them back to 'scheduled'
		// and start will take care of them

		$sql = "SELECT RID FROM tbl_schedule_details where status='recording'";
		$result = $orb->execute_select($sql);
		while($row = $result->fetch_row())
		{
			$rid = $row[0];
			echo "Checking on recording $rid\n";
			$reschedule = false;

			$sql = "SELECT tuner_ID, recording_slot FROM tbl_recording_details WHERE RID='$rid'";
			$result2 = $orb->execute_select($sql);
			if($row2 = $result2->fetch_row())
			{
				if($row[0] == $i)
				{
					if(isset($r["slot_$j"]))
					{
						// seems OK
					}
					else
					{
						$reschedule = true;
					}
				}
				else
				{
					echo "Hmmm, can't find it\n";
					$reschedule = true;
				}
			}
			if($reschedule)
			{
				echo "Re-scheduling recording $rid\n";
				$sql ="UPDATE tbl_schedule_details SET status='scheduled' WHERE RID='$rid'";
				$orb->execute_insert($sql);
			}
		}
	}
}



function initilise()
{
//need to populate the $muxy_socket array would be better with SQL


	global $orb;
	global $muxy_socket;

	$sql = "SELECT tuner_id,
		       sock_location
		FROM   tbl_tuner_details";

	$result = $orb->execute_select($sql);

	while($row = $result->fetch_row())
	{
		$muxy_socket[$row[0]] = $row[1];
		echo "Tuner $row[0] is at $row[1]\n";
	}
}



/*fuction used to test that the sockets are working. 
  at the moment it tests the 2 tuner cards that i have specified
*/

function socket_test()
{

	initilise();
	global $muxy_socket;




echo "testing muxy sockets\n";
	
	echo "Muxy socket test\n";
        //muxy_connect(0);
        //muxy_connect(1);
	$string_test = 'open 0x0430 muxy_test1.ts';
	$test_index1 = $muxy_socket[0];
	//$test_index1 = "/home/rshaw/fyproject/muxy-0.7/muxy0.sock";
	$test_index2 = $muxy_socket[1];
	//$test_index2 = "/home/rshaw/fyproject/muxy-0.7/muxy1.sock";
	//$test_index1 = '0';
	//$test_index1 = '0';
	
	//$test_index1 = '0';
	//$test_index2 = '1';
        muxy($test_index1, 'set frequency $frequency_9');
        muxy($test_index2, 'set frequency $frequency_7');
	sleep(1);
	muxy($test_index1, 'zap');
        muxy($test_index2, 'zap');
	sleep(1);
	//muxy('open 0x0430 muxy_test1.ts');
	$r = muxy($test_index1, $string_test);
	print_r($r);

/*
testing data
if(isset($r['slot']))
    {
	echo "in muxy isset\n";    
	$slot = $r['slot'];
        echo "Recording to slot $slot\n";
    }
*/


	$slot = $r['slot'];
	echo "muxy is recording on slot $slot\n";
	muxy($test_index2, 'open 0x0530 muxy2_test1.ts');
	sleep(20);
	muxy($test_index1, "close $slot");
	muxy($test_index2,  'close 0');
	sleep(1);
	muxy($test_index1, 'unzap');
	muxy($test_index2, 'unzap');
//	muxy('show all');
	
echo "finished muxy socket test\n";
}

initilise();
muxy_status();

// Main loop of the scheduler
while(true)
{
	$current_datetime = $orb->execute_count("SELECT NOW()");
	
	$funct_start_time = time();
	check_schedule($current_datetime);
	$funct_stop_time = time();

	//the diff time function calculates how long the muxy commands took to run, this then varies the amount of time scheduler sleeps for.	
	$sleep_time = diff_time($funct_start_time, $funct_stop_time);	

	for($i = 0; $i < $sleep_time; $i++)
	{
		echo "\r".date('H:i:s');
		sleep(1);
	}

	//make sure that muxy has not gone away...
	//muxy_status();
}

function diff_time($funct_start_time, $funct_stop_time)
{
	$check_frequency = 10;

	$time_taken = $funct_stop_time - $funct_start_time;
	$sleep_time = $check_frequency - $time_taken; // check every 10 seconds
	//echo "sleep time from diff_time = $sleep_time\n";

	return $sleep_time;
}

// This is called once every minute to do any work required
function check_schedule($current_datetime)
{
	global $orb;

	stop_check($current_datetime);
	cancel_check($current_datetime);
	missed_check($current_datetime);
	start_check($current_datetime);
}

function stop_check($current_datetime)
{
	global $orb;

	// also stop recordings which have been canceled....?

	$sql = "SELECT program_name,
		       tbl_schedule_details.rid,
             	       tbl_recording_details.recording_slot,
		       tuner_id
        	FROM   tbl_schedule_details,
	       	       tbl_recording_details
        	WHERE  stop <= '$current_datetime'
        	AND    tbl_schedule_details.rid = tbl_recording_details.rid
		AND    tbl_schedule_details.status = 'recording'";

	$stop_result = $orb->execute_select($sql);

	while($row = $stop_result->fetch_row())
     	{
		echo "\nIt is time to stop $row[0]\n";

		$rid = $row[1];
		//echo "RID = $row[1]\n";
		$slot = $row[2];
		//echo "STOP SLOT = $slot\n";
		$tuner_id = $row[3];


		close_slot($tuner_id, $slot);

		$sql = "UPDATE tbl_schedule_details
                       	SET    status  = 'finished',
			       rid     = NULL
                       	WHERE  rid     = '$rid'";
		
		$orb->execute_insert($sql);

		$sql = "UPDATE tbl_tuner_details
			SET    slots_open = slots_open - 1
			WHERE  tuner_id = '$tuner_id'";
		
		$orb->execute_insert($sql);

		unzap_unused_tuners();
	}
}

function cancel_check($current_datetime)
{
	global $orb;

	$sql = "SELECT program_name,
		       rid
        	FROM   tbl_schedule_details
        	WHERE  rid IS NOT NULL
		AND    status = 'canceled'";

	$check_result = $orb->execute_select($sql);

	while($row = $check_result->fetch_row())
     	{
		echo "\nIt is time to stop $row[0] because it was canceled\n";

		$rid = $row[1];

		$sql = "SELECT recording_slot,
		               tuner_id
			FROM   tbl_recording_details
			WHERE  rid = '$rid'";
		$result = $orb->execute_select($sql);
		if($row = $result->fetch_row())
		{
			// good, stop it	
			$slot = $row[0];
			$tuner_id = $row[1];

			close_slot($tuner_id, $slot);

			$sql = "UPDATE tbl_schedule_details
	                       	SET    status  = 'finished',
				       rid     = NULL
	                       	WHERE  rid     = '$rid'";
			
			$orb->execute_insert($sql);
	
			$sql = "UPDATE tbl_tuner_details
				SET    slots_open = slots_open - 1
				WHERE  tuner_id = '$tuner_id'";
			
			$orb->execute_insert($sql);

			unzap_unused_tuners();
		}
		else
		{
			// must be an old entry
			$sql = "UPDATE tbl_schedule_details
			        SET    rid = NULL
				WHERE  rid = '$rid'";
			$orb->execute_insert($sql);
		}
	}
	
}


/* Any record which starts in the past, and ends in the past and has not been record
had been 'missed' */
function missed_check($current_datetime)
{
	global $orb;

	$sql=   "SELECT program_name,
			start,
			channel_id
		 FROM   tbl_schedule_details 
		 WHERE  start < '$current_datetime'
		 AND    stop < '$current_datetime'
		 AND    status = 'scheduled'";

	$result = $orb->execute_select($sql);

	while($row = $result->fetch_row())
	{
		$prog_name = $row[0];
		$start = $row[1];

		echo "missed $prog_name which started at $start\n";

		$sql = "UPDATE tbl_schedule_details
		        SET    status = 'missed'
                WHERE      start           = '$start'
                AND        channel_id    = '$row[2]'";

        	$orb->execute_insert($sql);
	}
}

/*

	tbl_schedule_details.status values:
	'scheduled' = Scheduled but in the future
	'missed'    = Scheduled but in the past
	'recording' = Recording is in progress
	'finished'  = Recording is complete
*/

// new style.  Each nid has a single frequency
// should we check the group_id?
function get_frequency_for_nid($nid)
{
	global $orb;

	$sql = "SELECT channel_id
	        FROM   tbl_channel_identifier
		WHERE  attribute = 'nid'
		AND    identifier = '$nid'";

	$channel = $orb->execute_count($sql);
	if($channel != "")
	{
		echo "nid $nid is for network $channel\n";

		$sql = "SELECT identifier
		        FROM   tbl_channel_identifier
			WHERE  channel_id = '$channel'
			AND    attribute = 'frequency'";

		$frequency = $orb->execute_count($sql);
		return $frequency;
	}
	return "";
}

function get_tuner_on_frequency($frequency)
{
	global $orb;

        $sql= "SELECT tuner_id
               FROM   tbl_tuner_details
               WHERE  frequency = '$frequency'";

	$result = $orb->execute_select($sql);

	if($row = $result->fetch_row())
	{
		return $row[0];
	}
	else
	{
		return "";
	}
}

function get_idle_tuner()
{
	global $orb;

	$sql= "SELECT tuner_id
	       FROM   tbl_tuner_details
	       WHERE  status = 'idle'";

	$result = $orb->execute_select($sql);

	if($row = $result->fetch_row())
	{
		return $row[0];
	}
	else
	{
		return "";
	}
}

function zap_tuner($tuner_id, $frequency)
{
	global $orb;
	global $muxy_socket;

	muxy($muxy_socket[$tuner_id], "set frequency $frequency");
	muxy($muxy_socket[$tuner_id], "zap");

	// loop till we get zap_locked=yes or timeout

	$tries = 10;
	while($tries > 0)
	{
		$r = muxy($muxy_socket[$tuner_id], "show zap*");
		if(isset($r['zap_locked']) && $r['zap_locked'] == "yes")
		{
			// update the database to reflect the tuner being zapped...
			$sql = "UPDATE tbl_tuner_details SET frequency = '$frequency', status = 'recording' WHERE tuner_id='$tuner_id'";
			$orb->execute_insert($sql);

			return true;
		}
		else
		{
			$tries--;
			sleep(1);
		}
	}
	muxy($muxy_socket[$tuner_id], "unzap");
	return false;
}

// select tuners which are 'recording' but slots = 0
function unzap_unused_tuners()
{
	global $orb;
	global $muxy_socket;

	$sql = "SELECT tuner_id FROM tbl_tuner_details WHERE slots_open = 0 AND status = 'recording'";
	$result = $orb->execute_select($sql);

	while($row = $result->fetch_row())
	{
		$tuner_id = $row[0];
		muxy($muxy_socket[$tuner_id], "unzap");

		$sql = "UPDATE tbl_tuner_details SET status = 'idle', frequency = 0 WHERE tuner_id = '$tuner_id'";
		$orb->execute_insert($sql);
	}
}

function open_slot($tuner_id, $pid, $filename)
{
	global $muxy_socket;

	$tries = 10;
	while($tries > 0)
	{
		$open = "open $pid $filename";
		$r = muxy($muxy_socket[$tuner_id], $open);

		if(isset($r['slot']))
		{
			$slot = $r['slot'];

			return $slot;
		}
		else
		{
			$tries--;
			sleep(1);
		}
	}
        return -1;
}

function close_slot($tuner_id, $slot)
{
	global $muxy_socket;

	muxy($muxy_socket[$tuner_id], "close $slot");
}

function get_filename_for_recording($name)
{
	global $video_dir;
        $file_date = date('Y-m-d');

	$new_dir = $video_dir . $file_date .'-'.$name . '/';
	@mkdir($new_dir);

	// figure out a file name to use...
	for($tries = 0; $tries < 100; $tries++)
	{
		$filename = sprintf("$new_dir$file_date-$name-%02d.ts", $tries);
		if(!file_exists($filename))
		{
			break;
		}
	}

	return $filename;
}

function start_check($current_datetime)
{
	global $orb;

	$sql=   "SELECT program_name,
			channel_id,
			null,
			start
		 FROM   tbl_schedule_details 
		 WHERE  start <= '$current_datetime'
		 AND    status = 'scheduled'";

	$my_result = $orb->execute_select($sql);

	while($row = $my_result->fetch_row())
	{
		echo "\nIt is time to start $row[0]\n";
		$prog_name  = $row[0];
		$channel_id = $row[1];
		$start_time = $row[3];

		// we need to 
		// convert channel_id into into a frequency and pid
		// convert frequency into a tuner card (already zapped or idle)
		// open a slot on the tuner
		// allocate a recording ID 
		// update the schedule with the rid & status

		$frequency = get_attribute_for_channel_or_group($channel_id, 'frequency');
		$pid       = get_attribute_for_channel_or_group($channel_id, 'pid');

		if($frequency == "")
		{
			echo "\nCan't find a frequency for channel $channel_id\n";
		}

		$tuner = get_tuner_on_frequency($frequency);

		if($tuner == "")
		{
			$tuner = get_idle_tuner();

			if($tuner == "")
			{
				echo "No available tuners\n";
				continue;
			}
			else
			{
				echo "Tuner $tuner is available for use\n";
				if(!zap_tuner($tuner, $frequency))
				{
					echo "Unable to tune to required frequency\n";
					continue;
				}
			}
		}
		else
		{
			echo "Tuner $tuner is already on $frequency\n";
		}

		// by here we have a tuner ready to go

		$filename = get_filename_for_recording($prog_name);

		$slot = open_slot($tuner, $pid, $filename);

		if($slot >= 0)
		{
		        $sql = "UPDATE  tbl_tuner_details
		                SET     slots_open = slots_open + 1
		                WHERE   tuner_id = '$tuner'";
		
		        $orb->execute_insert($sql);

			$sql = "INSERT INTO tbl_recording_details (tuner_id, recording_slot) VALUES ('$tuner', '$slot')";
			$orb->execute_insert($sql);
			$sql = "SELECT LAST_INSERT_ID()";
			$rid = $orb->execute_count($sql);

		        $sql = "UPDATE tbl_schedule_details
		                SET        status  = 'recording',
		                           RID     = '$rid'
		                WHERE      start   = '$start_time'
		                AND        channel_id = '$channel_id'";
		
		        $orb->execute_insert($sql);

		}
		else
		{
			echo "Failed to open recording slot\n";

			// unzap...?
			// select tuners which are 'recording' but slots = 0?
		}
	}
	unzap_unused_tuners();
}

?>
