<?php
header('Content_type: text/plain');

if(file_exists("/opt/digital_orb/php_lib/lib_orb.php"))
{
	include "/opt/digital_orb/php_lib/lib_orb.php";
}
else
{
	include "../php_lib/lib_orb.php";
}

load_database();
load_libs(array("lib_dbedit.php"));

function decode_details($details)
{
	$properties = array();
	$details = explode(",", $details);
	foreach($details as $detail)
	{
		$detail = explode("=", $detail);
		if(sizeof($detail) == 2)
		{
			$properties[$detail[0]] = $detail[1];
		}
	}
	return $properties;
}

function output_full_xml()
{
	echo "<digital_orb>\n";
	output_channel_xml();
	output_epg_xml();
	output_recordings_xml();
	output_schedules_xml();
	echo "</digital_orb>\n";
}

function output_channel_xml()
{
	global $orb;

	echo "  <channels>\n";

	$tuner_class = array();
	$sql = "SELECT   tuner_class, 
	                 description 
	        FROM     tbl_tuner_class 
	        ORDER BY tuner_class";
	$result = $orb->execute_select($sql);
	while($row = $result->fetch_row())
	{
	        $tuner_class[] = $row[0];
			echo "<!-- tuner class \"$row[0]\" -->\n";
	}

	foreach($tuner_class as $class)
	{
	        $sql = "SELECT   tuner_id, 
	                         description 
	                FROM     tbl_tuner_instance
	                WHERE    tuner_class='$class'
	                ORDER BY tuner_id";
	        $result = $orb->execute_select($sql);
	        while($row = $result->fetch_row())
	        {
					echo "<!-- tuner \"$row[0]\" is class \"$class\" -->\n";
	        }
	}

	$channels = array();
	$channel_uids = array();

	$sql = "SELECT   channel_id, 
	                 channel_name, 
	                 network_name 
	        FROM     tbl_channel
	        ORDER BY channel_id";
	$result = $orb->execute_select($sql);

//$t->head(array("UID", "Name", "Network"));
	while($row = $result->fetch_row())
	{
	        $channels[$row[0]] = $row[1];
	        $channel_uids[$row[0]] = "{$row[0]}-{$row[1]}";
	        //echo "<!-- channel \"$row[0]\" name \"$row[1]\" network \"$row[2]\" -->\n";
	}

	foreach($tuner_class as $class)
	{
	        $r = array();
	        $tags = array();
	
	        $r[] = $class;
	        $tags[] = '';
	
	        foreach($channels as $key => $value)
	        {
	                $sql = "SELECT available, 
	                               group_id 
	                        FROM   tbl_channel_tuner 
	                        WHERE  tuner_class='$class' 
	                        AND    channel_id='$key'
	                        ORDER BY group_id";
	
	                $result = $orb->execute_select($sql);
	                if($row = $result->fetch_row())
	                {
	                        if($row[0] == 'F')
	                        {
								echo "<!-- channel \"$key\" class \"$class\" is not available -->\n";
	                        }
	                        else
	                        {
	                                if($row[1] > 0)
	                                {
	                                        $a = $row[1];
	                                        $tags[] = 'running';//'group';
											echo "<!-- channel \"$key\" class \"$class\" is group \"$row[1]\"-->\n";
	                                }
	                                else
	                                {
											echo "<!-- channel \"$key\" class \"$class\" is available-->\n";
	                                }
									echo "    <channel>\n";
									echo "      <name>$value</name>\n";
									echo "      <number>$key</number>\n";
									echo "      <class>$class</class>\n";
									echo "    </channel>\n";
	                        }
	                }
	                else
	                {
	                        // no record, must not be available
							echo "<!-- channel \"$key\" class \"$class\" is not available (no record) -->\n";
	                }
	        }
	}
	echo "  </channels>\n";
}

function output_epg_xml()
{
	global $orb;

	$date = $orb->execute_count("SELECT CURRENT_DATE");
	$start = $date;
	$stop  = $orb->execute_count("SELECT DATE_ADD('$date', INTERVAL 5 DAY)");
	$now   = $orb->execute_count("SELECT NOW()");

	$time     = "UNIX_TIMESTAMP(start_time)";// + utc_timestamp() - now())";
	$end_time = "UNIX_TIMESTAMP(end_time)";// + utc_timestamp() - now())";
	$channel  = "tbl_channel.channel_id";//"CONCAT(tbl_channel.channel_id, ' - ', channel_name)";

	$sql = "SELECT   $channel, 
	                 $time,
	                 $end_time, 
	                 title,
	                 data_source,
	                 data_source_id,
	                 start_time < '$now' AS started,
	                 end_time < '$now' AS finished,
					 sub_title,
					 description,
					 details,
					 epg_id
	        FROM     tbl_epg_program,
	                 tbl_channel
	        WHERE    end_time > '$start' 
	        AND      start_time   < '$stop'
	        AND      tbl_epg_program.channel_id = tbl_channel.channel_id
	        ORDER BY start_time,
	                 channel_name";
	
	echo "  <epg>\n";
	$result = $orb->execute_select($sql);
	while($row = $result->fetch_row())
	{
		$properties = decode_details($row[10]);
		
		echo "    <entry>\n";
		echo "      <id>$row[11]</id>\n";
		echo "      <channel>$row[0]</channel>\n";
		echo "      <start>$row[1]</start>\n";
		echo "      <end>$row[2]</end>\n";
		echo "      <title>$row[3]</title>\n";
		echo "      <subtitle>$row[8]</subtitle>\n";
		echo "      <plot>$row[9]</plot>\n";
		echo "      <data_source>$row[4]</data_source>\n";
		echo "      <data_source_id>$row[5]</data_source_id>\n";
		echo "      <started>$row[6]</started>\n";
		echo "      <finished>$row[7]</finished>\n";
		echo "      <category>{$properties['category']}</category>\n";
		echo "    </entry>\n";
	}
	
	echo "  </epg>\n";
}

function output_recordings_xml()
{
	global $orb;

	// recordings
	echo "  <recordings>\n";
	$sql = "SELECT program_name,
		           title
		    FROM   tbl_schedule_details
			WHERE  DATE_ADD(start, INTERVAL 1 YEAR) > NOW()
			AND    status IN ('recording','finished')";
			
	$result = $orb->execute_select($sql);
	while($row = $result->fetch_row())
	{
		$id = $row[0];
		$date = $orb->execute_count("SELECT DATE(start) FROM tbl_schedule_details WHERE program_name='$id'");
		$filename = "/tmp/video/$date-$id/$date-$id-??.ts";
	
		$files = glob($filename);
	
		if(sizeof($files) == 0)
		{
				echo "<!-- $id has been deleted -->\n";
		}
		else
		{
			$sid = preg_split('/-/', $id);
			$sql = "SELECT   tbl_channel.channel_name,
			                 UNIX_TIMESTAMP(start_time),
			                 UNIX_TIMESTAMP(end_time) - UNIX_TIMESTAMP(start_time),
						     title,
						     sub_title,
						     description,
							 details
					FROM     tbl_epg_program,
					         tbl_channel
					WHERE    data_source='$sid[0]'
					AND      data_source_id='$sid[1]'
					AND      tbl_epg_program.channel_id = tbl_channel.channel_id
					ORDER BY start_time,
					         channel_name";
	
			$result2 = $orb->execute_select($sql);
			if($row2 = $result2->fetch_row())
			{
				$properties = decode_details($row2[6]);
	
				echo "    <recording>\n";
				echo "      <id>$id</id>\n";
				echo "      <channel>$row2[0]</channel>\n";
				echo "      <start>$row2[1]</start>\n";
				echo "      <duration>$row2[2]</duration>\n";
				echo "      <title>$row2[3]</title>\n";
				echo "      <subtitle>$row2[4]</subtitle>\n";
				echo "      <path>/$date-$id/*.ts</path>\n";
				echo "      <category>{$properties['category']}</category>\n";
				echo "    </recording>\n";
			}
			else
			{
				echo "<!-- $id not found in the EPG -->\n";
			}
		}
	}
	echo "  </recordings>\n";
}

function output_schedules_xml()
{
	global $orb;

	echo "  <schedules>\n";
	$sql = "SELECT program_name,
		           title
		    FROM   tbl_schedule_details
			WHERE  stop > NOW()
			AND    status IN ('scheduled','recording')";
	$result = $orb->execute_select($sql);
	while($row = $result->fetch_row())
	{
		$id = $row[0];
		$date = $orb->execute_count("SELECT DATE(start) FROM tbl_schedule_details WHERE program_name='$id'");
	
			$sid = preg_split('/-/', $id);
			$sql = "SELECT   tbl_channel.channel_id,
			                 UNIX_TIMESTAMP(start_time),
			                 UNIX_TIMESTAMP(end_time),
						     title,
						     sub_title,
						     description,
							 details,
							 epg_id
					FROM     tbl_epg_program,
					         tbl_channel
					WHERE    data_source='$sid[0]'
					AND      data_source_id='$sid[1]'
					AND      tbl_epg_program.channel_id = tbl_channel.channel_id
					ORDER BY start_time,
					         channel_name";
	
			$result2 = $orb->execute_select($sql);
			if($row2 = $result2->fetch_row())
			{
				$properties = decode_details($row2[6]);
	
				echo "    <schedule>\n";
				echo "      <id>$row2[7]</id>\n";
				echo "      <channel>$row2[0]</channel>\n";
				echo "      <start>$row2[1]</start>\n";
				echo "      <end>$row2[2]</end>\n";
				echo "      <title>$row2[3]</title>\n";
				echo "      <subtitle>$row2[4]</subtitle>\n";
				echo "      <path>/$date-$id/</path>\n";
				echo "      <category>{$properties['category']}</category>\n";
				echo "    </schedule>\n";
			}
			else
			{
				echo "<!-- $id not found in the EPG -->\n";
			}
	}
	echo "  </schedules>\n";
}

if(array_key_exists('PATH_INFO', $_SERVER))
{
	$path_info = $_SERVER['PATH_INFO'];
}
else
{
	$path_info = "";
}

if($path_info == "")
{
	output_full_xml();
}
else if($path_info == "/record")
{
	$id = POG('id');
	//echo "Record $id\n";
	$sql = "SELECT CONCAT(data_source, '-', data_source_id) FROM tbl_epg_program WHERE epg_id = '$id'";
	$sid = $orb->execute_count($sql);
	//echo "$sid\n";

	disable_record_program($sid);
	$r = enable_record_program($sid);
	if($r)
	{
		echo "<digital_orb status=\"ok\">\n";
		echo "</digital_orb>\n";
	}
	else
	{
		echo "<digital_orb status=\"error\">\n";
		echo "</digital_orb>\n";
	}
}
else if($path_info == '/cancel')
{
	$id = POG('id');
	$sql = "SELECT CONCAT(data_source, '-', data_source_id) FROM tbl_epg_program WHERE epg_id = '$id'";
	$sid = $orb->execute_count($sql);

	$r = disable_record_program($sid);
	if($r)
	{
		echo "<digital_orb status=\"ok\">\n";
		echo "</digital_orb>\n";
	}
	else
	{
		echo "<digital_orb status=\"error\">\n";
		echo "</digital_orb>\n";
	}
}
else
{
	header("HTTP/1.0 404 Not Found");
}

//print_r($path_info);
//print_r($_GET);

?>
