<?php

if(file_exists("/opt/digital_orb/php_lib/lib_orb.php"))
{
	include "/opt/digital_orb/php_lib/lib_orb.php";
}
else
{
	include "../php_lib/lib_orb.php";
}


load_database();
load_libs(array("lib_dbedit.php", "lib_dynamic.php"));

/*
$DYNAMIC[] = 'DONTRECORD';
function dynamic_on_dontrecord()
{
	global $orb;

	$id = POG("id");

	//$sql = "DELETE FROM tbl_schedule_details WHERE program_name='$id' AND status = 'scheduled'";
	$sql = "UPDATE tbl_schedule_details SET status = 'canceled' WHERE program_name='$id'";
	$orb->execute_insert($sql);

	update_recording_easy($id);
}*/

check_dynamic();


function show_channels($update = false)
{
	global $orb;


	// The main table is tbl_channel

	// Channels are described by what tuners can receive them
	// tbl_channel_tuner

	// a tuner is an instance of a tuner_class
	// tbl_tuner_instance
	// tbl_tuner_class

	// channels can be grouped because they share a common attribute
	// such as being broadcast on the same transport/frequency/network

	// for each channel or channel_group, there are a number of attributes


	// we also do some sanity checks because the database does not
	// enforce any keys

	$tuner_class = array();
	$sql = "SELECT   tuner_class, 
	                 description 
		FROM     tbl_tuner_class 
		ORDER BY tuner_class";
	$result = $orb->execute_select($sql);
	$t = new Table(true, "epg");
	$t->caption("Tuner Classes");
	$t->head(array("Class", "Name"));
	while($row = $result->fetch_row())
	{
		$tuner_class[] = $row[0];
		$t->row($row);
	}
	$t->dump_else("No tuner classes are defined");

	foreach($tuner_class as $class)
	{
		$sql = "SELECT   tuner_id, 
		                 description 
			FROM     tbl_tuner_instance
			WHERE    tuner_class='$class'
			ORDER BY tuner_id";
		$result = $orb->execute_select($sql);
		$t = new Table(true, "epg");
		$t->caption("Tuners for class $class");
		$t->head(array("ID", "Name"));
		while($row = $result->fetch_row())
		{
			$t->row($row);
		}
		$t->dump_else("No tuners for class $class");
	}



	$channels = array();

	$sql = "SELECT   channel_id, 
	                 channel_name, 
		         network_name 
		FROM     tbl_channel
		ORDER BY channel_id";
	$result = $orb->execute_select($sql);

	$t = new Table(true, "epg");
	$t->caption("Channels");
	$t->head(array("UID", "Name", "Network"));
	while($row = $result->fetch_row())
	{
		$channels[$row[0]] = $row[1];
		$t->row($row);
	}
	$t->dump();


	// Now do a table of channel_id v tuner_class
	// available = 'F' => red
	// available = 'T' => green
	// group_id > 0 => yellow

	$t = new Table(true, "epg");
	$t->caption("Channel Availability Matrix");
	$head = array("Class");
	foreach($channels as $key => $value)
	{
		$head[] = "$value ($key)";
	}
	$t->head($head);
	foreach($tuner_class as $class)
	{
		$r = array();
		$tags = array();

		$r[] = $class;
		$tags[] = '';

		foreach($channels as $key => $value)
		{
			$sql = "SELECT available, 
			               group_id 
				FROM   tbl_channel_tuner 
				WHERE  tuner_class='$class' 
				AND    channel_id='$key'
				ORDER BY group_id";

			$result = $orb->execute_select($sql);
			if($row = $result->fetch_row())
			{
				if($row[0] == 'F')
				{
					$a = 'N';
					$tags[] = 'no';
				}
				else
				{
					if($row[1] > 0)
					{
						$a = $row[1];
						$tags[] = 'running';//'group';
					}
					else
					{
						$a = 'Y';
						$tags[] = 'yes';
					}
				}
				$a = href("?action=EDIT_AVAILABILITY&class=$class&channel=$key", $a);
				$r[] = $a;
			}
			else
			{
				// no record, must not be available
				$sql = "INSERT INTO tbl_channel_tuner (tuner_class, channel_id, available, group_id) VALUES ('$class', '$key', 'F', 0)";
				ipara("$sql;");
				$r[] = 'N';
				$tags[] = 'no';
			}
		}
		$t->row_tags = $tags;
		$t->row($r);
	}
	$t->dump();


	// now the attributes
	foreach($tuner_class as $class)
	{
		$sql = "SELECT DISTINCT attribute FROM tbl_channel_identifier WHERE tuner_class = '$class' order by attribute";
		$attributes = $orb->execute_select_array($sql);
		$t = new Table(true, "epg");
		$t->caption("Attributes for class $class");
		$t->row(array());
		$t->head(array_merge(array("UID", "Channel"),$attributes));
		foreach($channels as $channel => $value)
		{
			// was this channel available?
			$sql = "SELECT available FROM tbl_channel_tuner WHERE tuner_class = '$class' AND channel_id = '$channel'";
			$available = $orb->execute_count($sql);

			if($available == 'T')
			{
			
			$r = array();
			$tags = array();

			$r[] = $channel;
			$r[] = $value;
			$tags[] = "";
			$tags[] = "";

			$null = "^"; // something to click on for empty strings

			foreach($attributes as $attribute)
			{
				$allow_edit = false;

				// we want to know if the value comes from the channel or the group
				// so we are not using get_attribute_for_channel_or_group()
				$sql = "SELECT identifier
				        FROM   tbl_channel_identifier
					WHERE  tuner_class='$class'
				        AND    channel_id='$channel'
					AND    attribute='$attribute'";
				$result = $orb->execute_select($sql);
				if($row = $result->fetch_row())
				{
					// this is on the channel
					$a = $row[0];
					if($a == "")
					{
						$tags[] = 'no';
					}
					else
					{
						$tags[] = 'yes';
					}
					$allow_edit = true;
					if($allow_edit)
					{
						if($a == "")
						{
							$a = $null;
						}
							
						$a = href("?action=EDIT_ATTRIBUTE&class=$class&channel=$channel&attribute=$attribute", $a);
					}
					$r[] = $a;
				}
				else
				{
					// look at the group
					$sql = "SELECT group_id 
					        FROM   tbl_channel_tuner 
						WHERE  tuner_class='$class' 
						AND    channel_id='$channel' 
						AND    available='T'";

					$gid = $orb->execute_count($sql);

					if($gid == 0)
					{
						$r[] = '';
						$tags[] = 'no';
					}
					else
					{
						// now we can use the real function
						$a = get_attribute_for_channel_or_group($channel, $attribute);
						if($a == "")
						{
							$tags[] = 'no';
						}
						else
						{
							$tags[] = 'running';
						}

						// allow create (or override)
						$a.= href("?action=CREATE_ATTRIBUTE&class=$class&channel=$channel&attribute=$attribute", $null);
						$r[] = $a;
					}
				}
			}
			$t->row_tags = $tags;
			$t->row($r);
			}
		}
		$t->dump();
	}

/*
	if($update)
	{
		return $t->get_contents();
	}
	else
	{
		$t->dump();
	}*/
}

function show_edit_availability($tuner_class, $channel_id)
{
	global $orb;

	$values = array('F' => "Not Available",
	                'T' => "Available");

	$sql = "SELECT available, 
	               group_id 
		FROM   tbl_channel_tuner 
		WHERE  tuner_class='$tuner_class' 
		AND    channel_id='$channel_id'
		ORDER BY group_id";
	$result = $orb->execute_select($sql);
	$row = $result->fetch_row();
	if($row[0] == 'F')
	{
		$value = 'F';
	}
	else if($row[1] > 0)
	{
		$value = $row[1];
	}
	else
	{
		$value = 'T';
	}

	$sql = "SELECT DISTINCT group_id FROM tbl_channel_tuner WHERE group_id <> 0 ORDER BY group_id";
	$groups = $orb->execute_select_array($sql);
	foreach($groups as $group)
	{
		$values[$group] = "Available in group $group";
	}

	form();
	$t = new Table(true, "form");
	$t->caption("Editing availability for channel $channel_id on tuner class $tuner_class");
	$t->row(array("Availablity",  array_radio_buttons_new('available', $values, $value)));
	$t->row(array("", get_submit_button("Save")));
	$t->dump();
	insert_hidden("class", $tuner_class);
	insert_hidden("channel", $channel_id);
	insert_hidden("action", "SAVE_AVAILABILITY");
	eform();
}

function show_edit_attribute($tuner_class, $channel_id, $attribute)
{
	if($attribute == 'yahoo')
	{
		show_edit_attribute_yahoo($tuner_class, $channel_id, $attribute);
	}
	else
	{
		form();
		$t = new Table(true, "form");
		$t->caption("Editing attribute $attribute for channel $channel_id on tuner class $tuner_class");
		$t->row(array("Value", edit_box('value', 16, 64, get_attribute_for_channel_or_group($channel_id, $attribute))));
		$t->row(array("", get_submit_button("Save")));
		$t->dump();
		insert_hidden("class", $tuner_class);
		insert_hidden("channel", $channel_id);
		insert_hidden("attribute", $attribute);
		insert_hidden("action", "SAVE_ATTRIBUTE");
		eform();
	}
}

function show_edit_attribute_yahoo($tuner_class, $channel_id, $attribute)
{
	global $orb;

	$value = get_attribute_for_channel_or_group($channel_id, $attribute);

	$sql = "SELECT channel_name FROM tbl_epg_channels";
	$channels = $orb->execute_select_array($sql);
	if(!in_array($value, $channels))
	{
		$channels[] = $value;
	}
	if(!in_array("", $channels))
	{
		$channels[] = "";
	}

	form();
	$t = new Table(true, "form");
	$t->caption("Editing attribute $attribute for channel $channel_id on tuner class $tuner_class");
	$t->row(array("Value",array_combo_box('value', $channels, $value)));
	$t->row(array("", get_submit_button("Save")));
	$t->dump();
	insert_hidden("class", $tuner_class);
	insert_hidden("channel", $channel_id);
	insert_hidden("attribute", $attribute);
	insert_hidden("action", "SAVE_ATTRIBUTE");
	eform();
}

function save_edit_attribute($tuner_class, $channel_id, $attribute, $value)
{
	global $orb;

	$sql = "REPLACE INTO tbl_channel_identifier(tuner_class, channel_id, attribute, identifier) VALUES ('$tuner_class', '$channel_id', '$attribute', '$value')";
	$orb->execute_insert($sql);
}

function save_edit_availability($tuner_class, $channel_id, $value)
{	global $orb;

	if($value == 'F' || $value == 'T')
	{
		$available = $value;
		$group = 0;
	}
	else
	{
		$available = 'T';
		$group = $value;
	}

	$sql = "UPDATE tbl_channel_tuner SET available='$available', group_id='$group' WHERE tuner_class='$tuner_class' AND channel_id='$channel_id'";
	$orb->execute_insert($sql);
}
// main page output starts here

include "header.html";
enable_dynamic();

$action = POG("action");

if($action == "SAVE_ATTRIBUTE")
{
	$action = "";
	save_edit_attribute(POG('class'), POG('channel'), POG('attribute'), POG('value'));
}
else if($action == "SAVE_AVAILABILITY")
{
	$action = "";
	save_edit_availability(POG('class'), POG('channel'), POG('available'));
}

if($action == "EDIT_ATTRIBUTE" || $action == "CREATE_ATTRIBUTE")
{
	show_edit_attribute(POG('class'), POG('channel'), POG('attribute'));
}
else if($action == "EDIT_AVAILABILITY")
{
	show_edit_availability(POG('class'), POG('channel'));
}
else
{
	show_channels();
}

include "footer.html";
?>
