<?php

if(file_exists("/opt/digital_orb/php_lib/lib_orb.php"))
{
	include "/opt/digital_orb/php_lib/lib_orb.php";
}
else
{
	include "../php_lib/lib_orb.php";
}

load_database();
load_libs(array("lib_dbedit.php", "lib_dynamic.php"));

// epg specific functions

function get_class_for_recording($id, $started, $finished)
{
	global $orb;

	$classes = array("", "run", "recorded", "running", "recording", "scheduled", "starting", "stopping", "missed", "canceled", "deleted");

	$class = "UNKNOWN";

	$run = 0;
	if($started)
	{
		$run++;
	}
	if($finished)
	{
		$run++;
	}

	$sql = "SELECT status FROM tbl_schedule_details WHERE program_name='$id'";
	$result = $orb->execute_select($sql);
	if($row = $result->fetch_row())
	{
		$status = $row[0];
		if($status == "scheduled")
		{
			if($run == 0)
			{
				$class = "scheduled";
			}
			else if($run == 1)
			{
				$class = "starting";
			}
			else
			{
				$class = "missed";
			}
		}
		else if($status == "canceled")
		{
			if($run == 0 || $run == 1)
			{
				$class = "";
			}
			else
			{
				$class = "run";
			}
		}
		else if($status == "missed")
		{
			$class = "missed";
		}
		else if($status == "recording")
		{
			$class = "recording";
		}
		else if($status == "finished")
		{
			if($run == 0)
			{
				$class = "missed";
			}
/*			else if($run == 1)
			{
				$class = "stopping";
			}*/
			else if($run == 2 || $run == 1)
			{
				$class = "recorded";
				// does the file exists...?
				$date = $orb->execute_count("SELECT DATE(start) FROM tbl_schedule_details WHERE program_name='$id'");
				$filename = "/tmp/video/$date-$id/$date-$id-??.ts";

				$files = glob($filename);

				if(sizeof($files) == 0)
				{
					$class = "deleted";
				}
			}
			else
			{
				return $run;
			}
		}
	}
	else
	{
		// just a program that we don't care about
		if($run == 0)
		{
			// future
			$class = "";
		}
		else if($run == 1)
		{
			// this program is currentlty running
			$class = "running";
		}
		else
		{
			// this program is in the past
			$class = "run";
		}
	}

	if(!in_array($class, $classes))
	{
		echo "ERROR, class $class is unknown";
	}

	return $class;
}

function update_recording($id, $started, $finished)
{
	$class = get_class_for_recording($id, $started, $finished);
	for($i = 0; $i <= 5; $i++)
	{
		dynamic_set_class("$id-$i", $class);
	}
}

function update_recording_easy($id)
{
	global $orb;

	$now = $orb->execute_count("SELECT NOW()");
	$sql = "SELECT start_time < '$now' AS started,
		       end_time < '$now' AS finished
		FROM   tbl_epg_program 
		WHERE  data_source_id='$id'";
	$result = $orb->execute_select($sql);
	$row = $result->fetch_row();

	update_recording($id, $row[0], $row[1]);
}

$settings = array("early" => 5,
                  "late"  => 15);

$DYNAMIC[] = 'MANAGE';
function dynamic_on_manage()
{
	global $orb;
	$id = POG("id");
	//$sid = preg_split('/-/', $id);
	$date = $orb->execute_count("SELECT DATE(start) FROM tbl_schedule_details WHERE program_name='$id'");
	$filename = "/tmp/video/$date-$id/*.ts";
//	dynamic_show($filename);
	$filename = glob($filename);

	dynamic_show(implode(" ", $filename));
}

$DYNAMIC[] = 'INFO';
function dynamic_on_info()
{
	global $orb;
	$id = POG("id");
	$sid = preg_split('/-/', $id);
	$sql = "SELECT description, 
	               details,
				   sub_title
		FROM   tbl_epg_program 
		WHERE  data_source='$sid[0]'
		AND    data_source_id='$sid[1]'";

	$result = $orb->execute_select($sql);

	if($row = $result->fetch_row())
	{
		if(strlen($row[2]) > 0)
		{
			$row[2].= ". ";
		}
		dynamic_show($row[2].$row[0].$row[1]);
	}
}

$DYNAMIC[] = 'RECORD';
function dynamic_on_record()
{
	global $orb;
	global $settings;

	$early = $settings['early'];
	$late  = $settings['late'];

	$id = POG("id");
	$sid = preg_split('/-/', $id);

	$now = $orb->execute_count("SELECT NOW()");
	$sql = "SELECT DATE_SUB(start_time, INTERVAL $early MINUTE), 
	               DATE_ADD(end_time, INTERVAL $late MINUTE), 
		       channel_id,
		       start_time < '$now' AS started,
		       end_time < '$now' AS finished
		FROM   tbl_epg_program 
		WHERE  data_source='$sid[0]'
		AND    data_source_id='$sid[1]'";

	$result = $orb->execute_select($sql);
	if($row = $result->fetch_row())
	{
		$channel = $row[2];

		// if it already exists, remove it
		/*
		$sql = "DELETE FROM tbl_schedule_details WHERE program_name='$id'";
		$orb->execute_insert($sql);*/

		disable_record_program($id);

		// now add it back in 
		enable_record_program($id);

		/*
		$nid = get_attribute_for_channel_or_group($channel, 'nid');
		$pid = get_attribute_for_channel_or_group($channel, 'pid');
		$sql = "INSERT INTO tbl_schedule_details (start, stop, nid, pid, program_name) VALUES ('$row[0]', '$row[1]', '$nid', '$pid', '$id')";
		$orb->execute_insert($sql);*/

		update_recording($id, $row[3], $row[4]);
	}
	else
	{
		dynamic_show("Recording not found\n");
	}
}

$DYNAMIC[] = 'DONTRECORD';
function dynamic_on_dontrecord()
{
	global $orb;

	$id = POG("id");

	//$sql = "DELETE FROM tbl_schedule_details WHERE program_name='$id' AND status = 'scheduled'";
	$sql = "UPDATE tbl_schedule_details SET status = 'canceled' WHERE program_name='$id'";
	$orb->execute_insert($sql);

	update_recording_easy($id);
}

$DYNAMIC[] = 'EXPUNGE';
function dynamic_on_expunge()
{
	global $orb;

	$id = POG("id");

	//$sql = "DELETE FROM tbl_schedule_details WHERE program_name='$id' AND status = 'finished'";
	$sql = "UPDATE tbl_schedule_details SET status = 'canceled' WHERE program_name='$id'";
	$orb->execute_insert($sql);
	update_recording_easy($id);
}

$DYNAMIC[] = 'PLAY';
function dynamic_on_play()
{
	global $orb;

	$id = POG("id");

	$date = $orb->execute_count("SELECT DATE(start) FROM tbl_schedule_details WHERE program_name='$id'");

	$cmd = "sudo -H -u jnewbigin /home/jnewbigin/working/digital_orb/web/webplay-user /tmp/video/$date-$id/*.ts";
	exec ($cmd);
}

$DYNAMIC[] = 'DELETE';
function dynamic_on_delete()
{
	global $orb;

	$id = POG("id");

	$date = $orb->execute_count("SELECT DATE(start) FROM tbl_schedule_details WHERE program_name='$id'");
	$filename = "/tmp/video/$date-$id/$date-$id-??.ts";

	$cmd = "./td $filename";
	$cmd = "sudo -H -u jnewbigin /home/jnewbigin/bin/td $filename < /dev/null 2< /dev/null &";
	$cmd = "sudo -H -u jnewbigin /home/jnewbigin/bin/td $filename";

	exec($cmd);

	//$sql = "UPDATE tbl_schedule_details SET status='deleted' WHERE program_name'$id'";

	update_recording_easy($id);
}

$DYNAMIC[] = 'DAY';
function dynamic_on_day()
{
	// change viewing DAY
	$date = POG('day');

	dynamic_set_html("test", show_epg($date, true));
	dynamic_set_html("date", get_date_control($date));
}

$DYNAMIC[] = 'TODAY';
function dynamic_on_today()
{
	global $orb;

	// change viewing DAY
	$date = $orb->execute_count("SELECT CURRENT_DATE");

	dynamic_set_html("test", show_epg($date, true));
	dynamic_set_html("date", get_date_control($date));
}

$DYNAMIC[] = 'USAGE';
function dynamic_on_usage()
{
	global $orb;

	$s = `df -h`;
	$s = "<pre>$s</pre>";

	dynamic_set_html("test", $s);
}

$DYNAMIC[] = 'SCHEDULE';
function dynamic_on_schedule()
{
	global $orb;

	$id = POG("id");

	dynamic_set_html("test", get_schedule_form($id));
}

function get_schedule_form($id)
{
	global $orb;

	$sid = preg_split('/-/', $id);
	$channel  = "CONCAT(tbl_channel.channel_id, ' - ', channel_name)";
	$sql = "SELECT title, 
	               sub_title,
		       $channel
		FROM   tbl_epg_program,
		       tbl_channel
		WHERE  data_source='$sid[0]'
		AND    data_source_id='$sid[1]'
		AND    tbl_epg_program.channel_id = tbl_channel.channel_id";

	$result = $orb->execute_select($sql);

	if($row = $result->fetch_row())
	{
		$title = "^$row[0]$";
		$subtitle = "$row[1]";
		$chan = $row[2];
	}

	$t = new Table(true, "form");
	$t->row(array("Program Title", $title));
	$t->row(array("Program Sub-title", $subtitle));
	$t->row(array("Channel", $chan));
	$t->row(array("Simmulcast", "NYI"));
	$t->row(array("Repeat", "NYI"));
	return $t->get_contents();
}


// The dynamic handler.  This must only output javascript
// if dynamic actions are taken then the rest of the script does not run
check_dynamic();


//echo "<p style=\"cursor: pointer\" onclick=\"dynamic('TEST')\">Click for test</p>\n";


// Convert unicode escape into HTML unicode
// "\u00e9" -> "&#0233;"

function htmlunicode_replace($matches)
{
	$u = hexdec($matches[1]);
	return "&#$u;";
}

function htmlunicode($s)
{
	return preg_replace_callback('/\\\\u([0-9,a-f]{4})/', "htmlunicode_replace", $s);
}

function show_epg($date, $update = false)
{
	global $orb;

	$all_programs = array();


	$known_end_times = array();
	$never_show = array("Home Shopping", "Guthy-Renker Australia"); // load from database

	$start = $date;
	$stop  = $orb->execute_count("SELECT DATE_ADD('$date', INTERVAL 1 DAY)");
	$now   = $orb->execute_count("SELECT NOW()");

	$time     = "DATE_FORMAT(start_time,'%h:%i %p')";
	$duration = "SUBSTRING(SEC_TO_TIME(UNIX_TIMESTAMP(end_time) - UNIX_TIMESTAMP(start_time)), 1, 5)";
	$channel  = "CONCAT(tbl_channel.channel_id, ' - ', channel_name)";

	$sql = "SELECT   $channel, 
                         $time,
		         $duration, 
                         title,
			 data_source,
			 data_source_id,
			 start_time < '$now' AS started,
			 end_time < '$now' AS finished,
			 start_time,
			 end_time
                FROM     tbl_epg_program,
			 tbl_channel
                WHERE    end_time > '$start' 
                AND      start_time   < '$stop'
		AND	 tbl_epg_program.channel_id = tbl_channel.channel_id
                ORDER BY start_time,
		         channel_name";

	$result = $orb->execute_select($sql);

	$t = new Table(true, "epg");
	$t->head(array("Channel", "Time", "Duration", "Title", "Status", "Tools"));
	$future_links = new LinkSet(array("Info", "Record", "Cancel", "Schedule"));
	$future_links->icons = array("info", "record", "cancel", "schedule");
	$current_links   = new LinkSet(array("Info", "Play", "Stop", "Schedule"));
	$past_links      = new LinkSet(array("Info", "Play", "Delete", "Schedule", "Manage"));
	$deleted_links   = new LinkSet(array("Info", "",     "Delete", "Schedule"));
	while($row = $result->fetch_row())
	{
		$row[2] = strtr($row[2], array(":" => "h "))."m";
		$id       = $row[4].'-'.$row[5];
		$started  = $row[6];
		$finished = $row[7];
		$start_time = $row[8];
		$end_time   = $row[9];

		array_pop($row);
		array_pop($row);
		array_pop($row);
		array_pop($row);
		array_pop($row);
		array_pop($row);

		$all_programs[] = $id;

		$future_tools = array("INFO&amp;id=$id",
				      "RECORD&amp;id=$id",
		       		      "DONTRECORD&amp;id=$id",
				      "SCHEDULE&amp;id=$id");
		$current_tools = array("INFO&amp;id=$id",
		                       "PLAY&amp;id=$id",
		       		       "DONTRECORD&amp;id=$id",
				       "SCHEDULE&amp;id=$id");
		$past_tools = array("INFO&amp;id=$id",
		                    "PLAY&amp;id=$id",//.csg_encode("on_click=\"return true;\""), // csg_encode an on_click to stop the timer
		       		    "DELETE&amp;id=$id",
				    "SCHEDULE&amp;id=$id",
				    "MANAGE&amp;id=$id");
		$deleted_tools = array("INFO&amp;id=$id",
		                       "",
				       "EXPUNGE&amp;id=$id",
				       "SCHEDULE&amp;id=$id");
		if(in_array($row[3], $never_show))
		{
			// ignore
		}
		else
		{
			$row[3] = htmlentities($row[3]);
			$row[3] = htmlunicode($row[3]);
			$class = get_class_for_recording($id, $started, $finished);
			if($class == 'running')
			{
				$status = "On Now";
				$link = $future_links->get_dynamic($future_tools);
				$known_end_times[$row[0]] = $end_time;
			}
			else if($class == 'recording')
			{
				$status = "Recording Now";
				$link = $current_links->get_dynamic($current_tools);
				$known_end_times[$row[0]] = $end_time;
			}
			else if($class == 'recorded')
			{
				$status = "Recorded";
				$link = $past_links->get_dynamic($past_tools);
			}
			else if($class == 'deleted')
			{
				$status = "Deleted";
				$link = $deleted_links->get_dynamic($deleted_tools);
			}
			else if($class == 'scheduled')
			{
				$status = "Will Record";
				$link = $future_links->get_dynamic($future_tools);
			}
			else if($class == 'missed')
			{
				$status = "Not Recorded";
				$link = '';
			}
			else
			{
				// is this the next show?
				if(isset($known_end_times[$row[0]]) && $known_end_times[$row[0]] == $start_time)
				{
					$status = "On Next";
				}
				else
				{
					$status = "";
				}
				$link = $future_links->get_dynamic($future_tools);
			}
			$row[] = $status;
//		$row[3] .= $class;
			$row[] = $link;//s->get_dynamic($tools);
			$t->row_tags = $class;
			$t->row($row, "", $id);
		}
	}

	
	// manual recordings don't have an EPG entry
	$time     = "DATE_FORMAT(start,'%h:%i %p')";
	$duration = "SUBSTRING(SEC_TO_TIME(UNIX_TIMESTAMP(stop) - UNIX_TIMESTAMP(start)), 1, 5)";
	//$channel  = "CONCAT(tbl_channel.channel_id, ' - ', channel_name)";
	$sql = "SELECT   $time, 
	                 $duration, 
		         program_name, 
		         status, 
		         title, 
		         channel_id 
		FROM     tbl_schedule_details
                WHERE    stop > '$start' 
                AND      start   < '$stop'
                ORDER BY start,
		         channel_id";
	$result = $orb->execute_select($sql);
	while($row = $result->fetch_row())
	{
		// have we already show this?
		if(!in_array($row[2], $all_programs))
		{
			// add it...?
			$row[1] = strtr($row[1], array(":" => "h "))."m";

			$id = $row[2];
			
		$future_tools = array("INFO&amp;id=$id",
				      "RECORD&amp;id=$id",
		       		      "DONTRECORD&amp;id=$id",
				      "SCHEDULE&amp;id=$id");
		$current_tools = array("INFO&amp;id=$id",
		                       "PLAY&amp;id=$id",
		       		       "DONTRECORD&amp;id=$id",
				       "SCHEDULE&amp;id=$id");
		$past_tools = array("INFO&amp;id=$id",
		                    "PLAY&amp;id=$id",
		       		    "DELETE&amp;id=$id",
				    "SCHEDULE&amp;id=$id");

			$status = $row[3];

			if($status == "finished")
			{
				$link = $past_links->get_dynamic($past_tools);
				$status = "Recorded";
				$t->row_tags = 'recorded';
			}
			else if($status == "scheduled")
			{
				$link = $future_links->get_dynamic($future_tools);
				$status = "Will Record";
				$t->row_tags = 'scheduled';
			}
			else
			{
				$link = "";
				$t->row_tags = '';
			}
					
			$r = array($row[5], $row[0], $row[1], $row[4], $status, $link);
			$t->row($r);
		}
	}
	
	if($update)
	{
		return $t->get_contents();
	}
	else
	{
		$t->dump();
	}
}

function get_date_control($date)
{
	global $orb;

	$prev = $orb->execute_count("SELECT DATE_ADD('$date', INTERVAL -1 DAY)");
	$next = $orb->execute_count("SELECT DATE_ADD('$date', INTERVAL 1 DAY)");

	$day = $orb->execute_count("SELECT  DATE_FORMAT('$date', '%W')");


	$r = "";
	$r.= get_dynalink("&lt;-- ", 'DAY', array("day" => $prev));
	$r.= get_dynalink("$day $date", 'TODAY');
	$r.= get_dynalink(" --&gt;", 'DAY', array("day" => $next));

	$s = `/bin/df -h /tmp/video/ | grep -v Filesystem | tr -s ' '`;
	$s = explode(" ", $s);
	$s = "Disk is at $s[4] ($s[3] free)";
	$s = "<pre>$s</pre>";
	$r.= get_dynalink($s, 'USAGE');

	return $r;
}


// main page output starts here

include "header.html";
enable_dynamic();

script("
var n = 0;
var timerID = 0;
var timer_time = 1000;
var dynamic_loading = 0;

function UpdateTimer() 
{
   if(timerID) 
   {
       clearTimeout(timerID);
   }

   if(dynamic_loading > 0)
   {
     // we don't wan't to do anything while something is loading
	 n = 0;
   }
   n = n + 1;

   if(n >= 600)
   {
   	dynamic('TODAY');
	n = 0;
   }
   timerID = setTimeout(\"UpdateTimer()\", timer_time);

//   var x = document.getElementById(\"status\");
//   x.innerHTML=n;

}

function timer_stop()
{
   if(timerID) 
   {
       clearTimeout(timerID);
   }
   return false;
}

function timer_start()
{
	timer_stop();
	n = 100; 
	timerID  = setTimeout(\"UpdateTimer()\", timer_time);
}

timer_start();
");

$date = $orb->execute_count("SELECT CURRENT_DATE");
tag("div", get_date_control($date),"date");

echo get_script("
function pad(num, size) 
{
    var s = num + \"\";
    while (s.length < size) s = \"0\" + s;
    return s;
}

function date_changed(calendar)
{
	var y     = calendar.date.getFullYear();
	var m     = calendar.date.getMonth() + 1;
	var d     = calendar.date.getDate();

	var day = y + \"-\" + pad(m, 2) + \"-\" + pad(d, 2);

	dynamic(\"DAY&day=\" + day);
}");

// put in a calendar just for testing atm
                $control.= "<img src=\"spacer.gif\" id=\"trigger_calendar\" class=\"cal\" alt=\"Show Calendar\">";
		$from_year = 2011;
		$to_year = 2012;

                $control.= get_script("
				Calendar.setup({
				showsTime      :    false,            // will display a time selector
				button         :    \"trigger_calendar\",   // trigger for the calendar (button ID)
				align          :    \"bR\",           // alignment (defaults to Bl)
				singleClick    :    true,           // single-click mode
				inputField     :    \"temp_calendar\",
				ifFormat       :    \"%Y-%m-%d\",
				onSelect       :    date_changed,
				range          :    [$from_year, $to_year],
				weekNumbers    :    false,
				step           :    1                // show all years in drop-down boxes (instead of every other year as default)
				});");

echo $control;

eform();
show_epg($date);

include "footer.html";
?>
