<?php
$green = "#CCFF99";
$gold  = "#FFCC99";
$red   = "#FF6666";

$default_background_colors   = array("#FFEFFF", "#FFDFFF");
$highlight_background_colors = array("#CCFF99", "#CCFFA9");
$lowlight_background_colors  = array("#FFCC99", "#FFCCA9");

$default_background_colors_double = array("#FFEFFF","#FFEFFF", "#FFDFFF", "#FFDFFF");
$highlight_background_colors_double = array("#CCFFAF", "#CCFFAF", "#CCFFAF", "#CCFFAF");
$lowlight_background_colors_double = array("#FFCC99", "#FFCC99", "#FFCC99", "#FFCC99");


	/*
	 * Form layout helper functions
	 */

	// tag indent level
	$til = 6;

	function get_entity($tag)
	{
		global $til;
		return str_repeat(' ', $til)."<$tag>\n";
	}

	function entity($tag)
	{
		echo get_entity($tag);
	}

	function get_open_entity($tag, $inline = false)
	{
		global $til;
		$r = str_repeat(' ', $til)."<$tag>";
		if(!$inline)
		{
			$r.= "\n";
		}
		$til += 2;
		return $r;
	}

	function open_entity($tag)
	{
		echo get_open_entity($tag);
	}

	function get_close_entity($tag, $inline = false)
	{
		global $til;
		$til -= 2;
		if($til < 0)
		{
			$til = 0;
		}
		if($inline)
		{
			$r = "";
		}
		else
		{
			$r = str_repeat(' ', $til);
		}
		return $r."</$tag>\n";
	}

	function close_entity($tag)
	{
		echo get_close_entity($tag);
	}

	function amp($text)
	{
		return strtr($text, array("&" => "&amp;"));
	}

	function get_itext($text)
	{
		global $til;
		return str_repeat(' ', $til)."$text\n";
	}

	function itext($text)
	{
		echo get_itext($text);
	}

	function get_ipara($text)
	{
		global $script;

		if($script)
		{
			$r = "$text\n";
		}
		else
		{
			$r = get_open_entity('p');
			$r.= get_itext($text);
			$r.= get_close_entity('p');
		}
		return $r;
	}

	function ipara($text)
	{
		echo get_ipara($text);
	}

	function get_pretext($text, $class = "")
	{
		$r = get_open_entity('pre');
		$r.= $text."</pre>"; // /pre needs to be on the same line or you get a blank line in the output
		get_close_entity('pre'); // we must call this to keep the indentation counter happy
		return $r;
	}

	function pre_text($text, $class = "")
	{
		echo get_pretext($text, $class);
	}

	function hidden($id, $caption)
	{
		add_toggle();
		echo href("#\" onclick=\"return toggle_hidden('$id')", "+ $caption"); br();
		echo get_open_entity("div class=\"hidden\" id=\"$id\"");
	}

	function ehidden()
	{
		echo get_close_entity('div');
	}

	function tag($tag, $str, $id = "")
	{
		if($id == "")
		{
			$r = get_open_entity($tag);
		}
		else
		{
			$r = get_open_entity("$tag id=\"$id\"");
		}
		$r.= get_itext($str);
		$r.= get_close_entity($tag);
		echo $r;
	}

	function error_message($error) 
	{
		echo "<strong>$error</strong>";	
	}

	function get_strong($str)
	{
		$r = get_open_entity('strong');
		$r.= $str;
		$r.= get_close_entity('strong');
		return $r;
	}

	function heading($str, $level = 2)
	{
		itext("<h$level>$str</h$level>");
	}

	function get_heading($str, $level = 2)
	{
		return get_itext("<h$level>$str</h$level>");
	}

	function caption($str)
	{
		echo get_caption($str);
	}

	function get_caption($str)
	{
		$r = get_open_entity("h3");
		$r.= get_itext($str);
		$r.= get_close_entity("h3");
		return $r;
	}

	function br()
	{
		entity("br");
	}

	function font_color($color)
	{
		echo "<font color=\"$color\">";
	}

	function efont()
	{
		echo "</font>";
	}

	function pre($class = "")
	{
		if(strlen($class) > 0)
		{
			echo "<pre class=\"$class\">";
		}
		else
		{
			echo "<pre>";
		}
	}

	function epre()
	{
		echo "</pre>";
	}

	function table($color = "", $width = "")
	{
		if(strlen($width) > 0)
		{
			$width = " width=\"$width\"";
		}
		if(strlen($color) > 0)
		{
			//echo "<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\" bordercolor=\"$color\"$width>";
			echo "<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\"$width>";
		}
		else
		{
			echo "<table border=\"1\">";
		}
	}

	function get_table()
	{
		return get_open_entity("table border=\"1\"");
	}

	function thin_table()
	{
		echo "<table border=\"0\">";
	}

	function etable()
	{
		echo get_etable();
	}

	function get_etable()
	{
		return get_close_entity("table");
	}

	function tr()
	{
		echo "<tr>";
	}

	function get_tr($class = "", $id = "")
	{
		if(strlen($class) > 0)
		{
			if(strlen($id) > 0)
			{
				return get_open_entity("tr class=\"$class\" id=\"$id\"");
			}
			else
			{
				return get_open_entity("tr class=\"$class\"");
			}
		}
		else
		{
			return get_open_entity("tr");
		}
	}

	function etr()
	{
		close_entity("tr");
	}

	function get_etr()
	{
		return get_close_entity("tr");
	}

	function get_td($span = 0)
	{
		if($span > 0)
		{
			return "<td valign=\"top\" colspan=\"$span\"><font face=\"Arial\">";
		}
		else
		{
			return "<td valign=\"top\"><font face=\"Arial\">";
		}
	}

	function get_td_class($class = "", $span = "", $id = "")
	{
		if(strlen($class) > 0)
		{
			$class = " class=\"$class\"";
		}
		if(strlen($span) > 0)
		{
			$span = " colspan=\"$span\"";
		}
		if(strlen($id) > 0)
		{
			$id = " id=\"$id\"";
		}
		return get_open_entity("td scope=\"col\"$class$span$id", true);
	}

	function get_th_class($class = "", $span = "")
	{
		if(strlen($class) > 0)
		{
			$class = " class=\"$class\"";
		}
		if(strlen($span) > 0)
		{
			$span = " colspan=\"$span\"";
		}
		return get_open_entity("th scope=\"col\"$class$span");
	}

	function get_etd_class()
	{
		return get_close_entity("td", true);
	}

	function get_eth_class()
	{
		return get_close_entity("th");
	}

	function td($span = 0)
	{
		echo get_td($span);
	}

	function get_td_color($color, $span = 0)
	{
		if($span > 0)
		{
			$colspan = " colspan=\"$span\"";
		}
		if(is_array($color))
		{
			$r = "<td valign=\"top\"$colspan bgcolor=\"$color[1]\"><font face=\"Arial\" color=\"$color[0]\">";
		}
		else
		{
			$r = "<td valign=\"top\"$colspan bgcolor=\"$color\"><font face=\"Arial\">";
		}
		return $r;
	}
	
	function td_color($color)
	{
		echo get_td_color($color);
	}

	function etd()
	{
		echo "</font></td>";
	}

	function get_etd()
	{
		return "</font></td>";
	}

	function get_table_head($data, $color = "")
	{
		$r = "";
		$r.= get_tr();
		foreach($data as $s)
		{
			if(strlen($color) > 0)
			{
				$r.= get_td_color($color);
			}
			else
			{
				$r.= get_td();
			}
			if(strlen($s) > 0)
			{
				$r.= "<b>$s</b>";
			}
			else
			{
				$r.= '&nbsp;';
			}
			$r.= get_etd();
		}
		$r.= get_etr();

		return $r;
	}
	
	function table_head($data)
	{
		echo get_table_head($data);
	}

	function table_head_span($data, $span)
	{
		tr();
		for($i = 0; $i < sizeof($data); $i++)
		{
			$s = $data[$i];
			td($span[$i]);
			if(strlen($s) > 0)
			{
				echo "<b>$s</b>";
			}
			else
			{
				echo '&nbsp;';
			}
			etd();
		}
		etr();
	}

	function get_table_head_class($data, $class, $span="")
	{
		$r = "";
		$r.= get_tr();
		foreach($data as $i => $s)
		{
			if(is_array($span))
			{
				$r.= get_th_class("", $span[$i]);
			}
			else
			{
				$r.= get_th_class();
			}
			if(strlen($s) > 0)
			{
				$r.= get_itext($s);
			}
			else
			{
				$r.= get_itext('&nbsp;');
			}
			$r.= get_eth_class();
		}
		$r.= get_etr();

		return $r;
	}

	function get_table_row_class($data, $class, $span="", $row_tags="", $id="")
	{
		$r = "";
		$r.= get_tr($class, $id);
		foreach($data as $i => $s)
		{
			if(is_array($row_tags))
			{
				$cell_class = $row_tags[$i];
			}
			else
			{
				$cell_class = "";
			}
			if(is_array($span))
			{
				$cell_span = $span[$i];
			}
			else
			{
				$cell_span = "";
			}
			$r.= get_td_class($cell_class, $cell_span, "$id-$i");
			if(strlen($s) > 0)
			{
				$r.= $s;
			}
			else
			{
				// is this needed?  This is now a CSS issue
				$r.= '&nbsp;';
			}
			$r.= get_etd_class();
		}
		$r.= get_etr();

		return $r;
	}

	function get_table_row($data, $color = "", $extra_tag = "", $span = "")
	{
		$r = "";
		if(is_array($data))
		{
			$r.= get_tr();
			$k = 0;
			foreach($data as $s)
			{
				if(strlen($color) > 0)
				{
					if(is_array($span))
					{
						$r.= get_td_color($color, $span[$k]);
					}
					else
					{
						$r.= get_td_color($color);
					}
				}
				else
				{
					$r.= get_td();
				}
				if(strlen($s) > 0)
				{
					if(is_array($extra_tag))
					{
						for($i = 0; $i < sizeof($extra_tag); $i++)
						{
							$r.= "<".$extra_tag[$i].">";
						}
					}
					$r.= $s;
					if(is_array($extra_tag))
					{
						for($i = sizeof($extra_tag) - 1; $i >= 0; $i--)
						{
							$r.= "</".$extra_tag[$i].">";
						}
					}
				}
				else
				{
					$r.= '&nbsp;';
				}
				$r.= get_etd();
				$k++;
			}
			$r.= get_etr();
		}
		else
		{
			$r.= get_table_row(array($data));
		}
		return $r;
	}
	
	function table_row($data, $color = "")
	{
		echo get_table_row($data, $color);
	}

	function get_insert_hidden($name, $value)
	{
		return get_entity("input type=\"hidden\" name=\"$name\" value=\"$value\"");
	}

	function insert_hidden($name, $value)
	{
		echo get_insert_hidden($name, $value);
	}

	function get_submit_button($caption, $extra="")
	{
		return get_entity("input type=\"submit\" value=\"$caption\"$extra");
	}

	function submit_button($caption)
	{
		echo get_submit_button($caption);
	}

	function get_form($extra = "")
	{
		$r = get_open_entity("form method=\"POST\" action=\"".$_SERVER['PHP_SELF']."$extra\"");
		$r.= get_open_entity("div");
		return $r;
	}

	function get_form2($extra = "")
	{
		$r = get_open_entity("form method=\"POST\" action=\"$extra\"");
		$r.= get_open_entity("div");
		return $r;
	}

	function form($extra = "")
	{
		echo get_form($extra);
	}

	function form2($extra = "")
	{
		echo get_form2($extra);
	}

	function get_eform()
	{
		$r = get_close_entity("div");
		$r.= get_close_entity("form");
		return $r;
	}

	function eform()
	{
		echo get_eform();
	}

	function edit_box($name, $len, $maxlen, $value)
	{
		return "<input type=\"text\" name=\"$name\" size=\"$len\" value=\"$value\" maxlength=\"$maxlen\">";
	}

	function password_box($name, $len, $maxlen, $value)
	{
		return "<input type=\"password\" name=\"$name\" size=\"$len\" value=\"$value\" maxlength=\"$maxlen\">";
	}

	function check_box($name, $value, $checked, $extra = "")
	{
		if($checked)
		{
			$check = " checked";
		}
		else
		{
			$check = "";
		}
		return "<input type=\"checkbox\" name=\"$name\" value=\"$value\"$check$extra>";
	}
	

	function memo_box($name, $rows, $cols, $value)
	{
		if($rows == 0)
		{
			for($i = 0; $i < strlen($value); $i++)
			{
				if($value[$i] == "\n")
				{
					$rows++;
				}
			}
			$rows++;
		}
		$component = "<textarea rows=\"$rows\" name=\"$name\" cols=\"$cols\">";
		$component.= $value;
		$component.="</textarea>";

		return $component;
	}

	function number_combo_box($name, $from, $to, $value, $extra="", $digits = 0)
	{
		$r = "<select name=\"$name\"".$extra.">\n";
		for($i = $from; $i <= $to; $i++)
		{
			if($digits > 0)
			{
				$text = sprintf("%02d", $i);
			}
			else
			{
				$text = $i;
			}
			$r .= "<option ".($i == $value ? "selected " : "")."value=\"$i\">$text</option>\n";
		}
		$r .= "</select>";

		return $r;
	}

	function array_combo_box($name, $items, $value, $extra="")
	{
		$r = "<select name=\"$name".$extra."\">\n";
		for($i = 0; $i < sizeof($items); $i++)
		{
			$r .= "<option ".($items[$i] == $value ? "selected " : "")."value=\"$items[$i]\">$items[$i]</option>\n";
		}
		$r .= "</select>";

		return $r;
	}

	// if $values == "" then the array key will be used instead
	function array_combo_box_values($name, $items, $values, $value, $extra="")
	{
		if(sizeof($items) == 1)
		{
			foreach($items as $i => $item)
			{
				if(is_array($values))
				{
					$v = $values[$i];
				}
				else
				{
					$v = $i;
				}
				$r = get_itext($item);
				$r.= get_insert_hidden($name, $v);
			}
		}
		else
		{
			$r = get_open_entity("select name=\"$name".$extra."\"");

			foreach($items as $i => $item)
			{
				if(is_array($values))
				{
					$v = $values[$i];
				}
				else
				{
					$v = $i;
				}
			
				if(strcmp($v, $value) == 0)
				{
					$selected = "selected ";
				}
				else
				{
					$selected = "";
				}
				$r.= get_open_entity("option $selected value=\"$v\"");
				$r.= get_itext($item);
				$r.= get_close_entity("option");
			}
			$r .= get_close_entity("select");
		}
		return $r;
	}

	/*
	 * This function maps Y/N into Yes No for human consumption
	 */
	function yes_no_combo($name, $value)
	{
		return array_combo_box_values($name, array('Yes', 'No'), array('Y', 'N'), $value);
	}

	function array_radio_buttons($name, $items, $value)
	{
		return array_radio_button_values($name, $items, $items, $value);
	}

	function array_radio_button_values($name, $items, $values, $value)
	{
		$r = "";
		for($i = 0; $i < sizeof($items); $i++)
		{
			$v = $values[$i];
			if($v == $value)
			{
				$checked = " checked";
			}
			else
			{
				$checked = "";
			}
			$r.= "<input type=\"radio\" name=\"$name\" value=\"$v\"$checked> $items[$i]<br>";
		}
		return $r;
	}

	function array_radio_buttons_new($name, $items, $value)
	{
		$r = "";
		foreach($items as $i => $v)
		{
			if($i == $value)
			{
				$checked = " checked";
			}
			else
			{
				$checked = "";
			}
			$r.= "<input type=\"radio\" name=\"$name\" value=\"$i\"$checked> $v<br>";
		}
		return $r;
	}

	function fileupload_box($name, $len, $maxlen, $value, $acceptlist)
	{
		return "<input type=\"file\" name=\"$name\" size=\"$len\" value=\"$value\" maxlength=\"$maxlen\" accept=\"$acceptlist\" >";
	}


	/*
	 * Returns an a tag with the requested url and text which will not show the url in the status bar
	 * this function can be combined with confirm like this
	 * echo href($url.confirm("join this team"), "Join this team");
	 * Also escapes & characters which are often used in URL's
	 */
	function href($url, $text)
	{
		global $csg_dev_site;

		$url = strtr($url, array('&' => '&amp;'));
		if($url[0] == '?')
		{
			// no URL on this HREF, we will use PHP_SELF
			$url = $_SERVER['PHP_SELF'].$url;
		}
		if(!$csg_dev_site)
		{
			$hide = "  onmouseover=\"status='';return true\"";
		}
		$r = get_open_entity("a href=\"$url\"$hide");
		$r.= get_itext($text);
		$r.= get_close_entity("a");
		return $r;
	}

	/*
	 * If the string ends in a " then move it to the start of the string
	 * This can then be used with functions which can accept an optional html tag
	 */
	function csg_encode($string)
	{
		$len = strlen($string);
		if(substr($string, $len - 1, 1) == '"')
		{
			$string = '" '.substr($string, 0, $len - 1);
		}
		return $string;
	}
	

	/*
	 * use tbl_subject_parameters and tbl_subject_config for now.
	 * This should be changed to tbl_parameters where asdf="subject"
	 *
	 */

	 function db_create_form($tableid)
	 {
	 	$sql = "SELECT param_name, param_desc FROM ".$tableid."_parameters ORDER BY ord";

		$result = execute_select($sql);

		table();
		table_head(array("column name", "description", "type", "size"));
		while($row = fetch_row($result))
		{
			// get the details of this field from the conf table...
			$field_info = get_field_info($tableid, $row[0]);
			
			table_row(array($row[0], $row[1], $field_info[0], $field_info[1]));
		}
		etable();

	 }

	 function load_db_field_info($tableid, $where)
	 {
	 	$table_param = $tableid."_parameters";

		// see if there is a table called $tableid...
		$sql = "SHOW TABLES LIKE '$tableid'";
		$result = execute_select($sql);
		if(fetch_row($result) > 0)
		{
	 		$table_data = $tableid;
		}
		else
		{
	 		$table_data = $tableid."_config";
		}
		
	 	$sql = "SELECT param_name, param_desc FROM $table_param"; // "WHERE param_set="subject" ORDER BY ord";

		$result = execute_select($sql);

		$name = array();
		$desc = array();
		$type = array();
		$len = array();

		while($row = fetch_row($result))
		{
			// get the details of this field from the conf table...
			$field_info = get_field_info($table_data, $row[0]);
			if(!is_array($field_info))
			{
				echo "Field $row[0] does not exist in $table_data<br>\n";
				die;
			}
			else
			{
				array_push($name, $row[0]);
				array_push($desc, $row[1]);
				array_push($type, $field_info[0]);
				array_push($len, $field_info[1]);
			}
		}
		free_result($result);

		return array("name" => $name, "desc" => $desc, "type" => $type, "len" => $len, "table" => $table_data);
	}

	function get_record_data($tableid, $where, $name)
	{
		$sql = "SELECT ";
		for($i = 0; $i < sizeof($name); $i++)
		{
			if($i != 0)
			{
				$sql .= ",";
			}
			$field = $name[$i];
			$sql .= $field;
		}
		$sql .= " FROM $tableid WHERE ".$where;

		$result = execute_select($sql);
		return $result;
	}

	function date_box($name, $value)
	{
		$year  = substr($value, 0, 4);
		$month = substr($value, 5, 2);
		$day   = substr($value, 8, 2);

		$current_year = date('Y');
		$from_year = min($year, $current_year) - 5;
		$to_year   = max($year, $current_year) + 5;

		$control = "";
        $control.= number_combo_box("year_$name", $from_year, $to_year, $year, "id=\"year_$name\" onChange=\"date_combo_changed(this.id)\"", 4);
        $control.= "-";
        $control.= number_combo_box("month_$name", 01, 12, $month, "id=\"month_$name\" onChange=\"date_combo_changed(this.id)\"", 2);
        $control.= "-";
        $control.= number_combo_box("day_$name", 01, 31, $day, "id=\"day_$name\" onChange=\"date_combo_changed(this.id)\"", 2);

	    $control.= get_insert_hidden("temp_$name\" id=\"temp_$name", "$year-$month-$day $hour:$min");
        $control.= "<img src=\"/images/icons/spacer.gif\" id=\"trigger_$name\" class=\"cal\" alt=\"Show Calendar\">";

		$control.= get_script("
Calendar.setup({
showsTime      :    false,            // will display a time selector
button         :    \"trigger_$name\",   // trigger for the calendar (button ID)
align          :    \"bR\",           // alignment (defaults to Bl)
singleClick    :    true,           // single-click mode
inputField     :    \"temp_$name\",
ifFormat       :    \"%Y-%m-%d\",
onSelect       :    date_changed,
range          :    [$from_year, $to_year],
weekNumbers    :    false,
step           :    1                // show all years in drop-down boxes (instead of every other year as default)
});");

		print_date_script();

		return $control;
	}

	function date_time_box($name, $value, $include_seconds = false)
	{
		global $date_script_printed;
		
		$year  = substr($value, 0, 4);
		$month = substr($value, 5, 2);
		$day   = substr($value, 8, 2);

		$hour  = substr($value, 11, 2);
		$min   = substr($value, 14, 2);
		$sec   = substr($value, 17, 2);

		$current_year = date('Y');
		$from_year = min($year, $current_year) - 5;
		$to_year   = max($year, $current_year) + 5;
		
		$control = "Date:";
        $control.= number_combo_box("year_$name", $from_year, $to_year, $year, "id=\"year_$name\" onChange=\"date_combo_changed(this.id)\"", 4);
        $control.= "-";
        $control.= number_combo_box("month_$name", 01, 12, $month, "id=\"month_$name\" onChange=\"date_combo_changed(this.id)\"", 2);
        $control.= "-";
        $control.= number_combo_box("day_$name", 01, 31, $day, "id=\"day_$name\" onChange=\"date_combo_changed(this.id)\"", 2);
        $control.= " Time:";
        $control.= number_combo_box("hour_$name", 00, 23, $hour, " id=\"hour_$name\" onChange=\"date_combo_changed(this.id)\"", 2);
        $control.= ":";
        $control.= number_combo_box("min_$name", 00, 59, $min, "id=\"min_$name\" onChange=\"date_combo_changed(this.id)\"", 2);
		if($include_seconds)
		{
	        $control.= ":";
	        $control.= number_combo_box("sec_$name", 00, 59, $sec, "id=\"sec_$name\" onChange=\"date_combo_changed(this.id)\"", 2);
		}
		else
		{
			$control.= get_insert_hidden("sec_$name\" id=\"sec_$name", $sec);
		}
	    $control.= get_insert_hidden("temp_$name\" id=\"temp_$name", "$year-$month-$day $hour:$min");
        $control.= "<img src=\"/images/icons/spacer.gif\" id=\"trigger_$name\" class=\"cal\" alt=\"Show Calendar\">";

		$control.= get_script("
Calendar.setup({
showsTime      :    true,            // will display a time selector
button         :    \"trigger_$name\",   // trigger for the calendar (button ID)
align          :    \"bR\",           // alignment (defaults to Bl)
singleClick    :    true,           // single-click mode
inputField     :    \"temp_$name\",
ifFormat       :    \"%Y-%m-%d %H:%M\",
onSelect       :    date_changed,
range          :    [$from_year, $to_year],
weekNumbers    :    false,
step           :    1                // show all years in drop-down boxes (instead of every other year as default)
});");

		print_date_script();

		return $control;
	}

	$date_script_printed = false;
	function print_date_script()
	{
		global $date_script_printed;

		if(!$date_script_printed)
		{
			$date_script_printed = true;
			script('
function date_combo_changed(x)
{
    var name=document.getElementById(x).name;
    var i = name.indexOf("_");
    name = name.substr(i + 1);

    var year  = document.getElementById("year_"+name);
    var month = document.getElementById("month_"+name);
    var day   = document.getElementById("day_"+name);
    var hour  = document.getElementById("hour_"+name);
    var min   = document.getElementById("min_"+name);
    var temp  = document.getElementById("temp_"+name);

	if(hour)
	{
	    temp.value = year.value+"-"+month.value+"-"+day.value+" "+hour.value+":"+min.value;
	}
	else
	{
	    temp.value = year.value+"-"+month.value+"-"+day.value;
	}
}

function date_changed(calendar)
{
    var name = calendar.params["inputField"].name.substr(5);

    var y     = calendar.date.getFullYear();
    var year  = document.getElementById("year_"+name);

    var m     = calendar.date.getMonth();
    var month = document.getElementById("month_"+name);

    var d     = calendar.date.getDate();
    var day   = document.getElementById("day_"+name);

    var h     = calendar.date.getHours();
    var hour  = document.getElementById("hour_"+name);

    var mn    = calendar.date.getMinutes();
    var min   = document.getElementById("min_"+name);

    var temp  = document.getElementById("temp_"+name);

    // the year can not be directly indexed so we need to search...
    for(i = 0; i < year.options.length; i++)
    {
        if(year.options[i].text == y)
        {
            year.options.selectedIndex = i;
            break;
        }
    }
    month.options.selectedIndex = m;
    day.options.selectedIndex = d - 1;
    hour.options.selectedIndex = h;
    min.options.selectedIndex = mn;

    m = m + 1;
    // save this so when the calendar is opened again it has the correct value
    temp.value = y+"-"+m+"-"+d+" "+h+":"+mn;

    return true;
};');
		}
	}

	/*
	 * TODO: check to see if there is an array of dates....
	 */
	function get_post_date($name)
	{
		$year  = $_POST["year_$name"];
		$month = $_POST["month_$name"];
		$day   = $_POST["day_$name"];

		return sprintf("%04d-%02d-%02d", $year, $month, $day);
	}

	function get_post_date_time($name)
	{
		$year  = $_POST["year_$name"];
		$month = $_POST["month_$name"];
		$day   = $_POST["day_$name"];
		$hour  = $_POST["hour_$name"];
		$min   = $_POST["min_$name"];
		$sec   = $_POST["sec_$name"];
		
		return sprintf("%04d-%02d-%02d %02d:%02d:%02d", $year, $month, $day, $hour, $min, $sec);
	}

	 function db_create_edit_form($tableid, $where, $hidden=array())
	 {
	 	$info = load_db_field_info($tableid, $where);
		$name = $info["name"];
		$desc = $info["desc"];
		$type = $info["type"];
		$len = $info["len"];

		$table_data = $info["table"];


		// now get the data for this record....
		$result = get_record_data($table_data, $where, $name);

		if($row = fetch_row($result))
		{
			// draw the table...
			form();
			table();
			table_head(array("Description", "Value"));
			for($i = 0; $i < sizeof($name); $i++)
			{
				if($type[$i] == "string")
				{
					$control = edit_box($tableid."data_".$name[$i], min($len[$i], 32), $len[$i], $row[$i]);
					table_row(array($desc[$i], $control));
				}
				else if($type[$i] == "int")
				{
					$control = edit_box($tableid."data_".$name[$i], $len[$i], $len[$i], $row[$i]);
					table_row(array($desc[$i], $control));
				}
				else if($type[$i] == "enum")
				{
					$values = get_enum_values($table_data, $name[$i]);
					$control = array_combo_box($tableid."data_".$name[$i], $values, $row[$i]);
					table_row(array($desc[$i], $control));
				}
				else if($type[$i] == "datetime")
				{
					$control = date_time_box($tableid."data_".$name[$i], $row[$i]);
					table_row(array($desc[$i], $control));
				}
				else
				{
					// I don't know how to let you edit this field...
					table_row(array($desc[$i]."($type[$i])", $row[$i]));
				}
			}
			etable();
			insert_hidden("tableid", $tableid);
			insert_hidden("where", $where);
			insert_hidden("action", "UPDATE_TABLE_DATA");

			$keys = array_keys($hidden);
			foreach($keys as $key)
			{
				insert_hidden($key, $hidden[$key]);
			}
			submit_button("Update");
			eform();
		}
		else
		{
			echo "No row found to match WHERE $where<br>\n";
		}
		free_result($result);

	 }

	 function db_update_data($tableid, $where)
	 {
	 	GLOBAL $HTTP_POST_VARS;

	 	$info = load_db_field_info($tableid, $where);

		$name = $info["name"];
		$desc = $info["desc"];
		$type = $info["type"];
		$len = $info["len"];
		$table_data = $info["table"];

		$update = "";

		$result = get_record_data($table_data, $where, $name);
		if($row = fetch_row($result))
		{
			for($i = 0; $i < sizeof($name); $i++)
			{
				if($type[$i] == "string" || $type[$i] == "enum")
				{
					$val = $HTTP_POST_VARS[$tableid."data_".$name[$i]];
					if($val != $row[$i])
					{
						//echo "New value = ".$val."<br>\n";
						if(strlen($update) > 0)
						{
							$update .= ",";
						}
						$update .= $name[$i]."='".$val."'";
					}
				}
				else if($type[$i] == "int")
				{
					$val = $HTTP_POST_VARS[$tableid."data_".$name[$i]];
					if($val != $row[$i])
					{
						if(strlen($update) > 0)
						{
							$update .= ",";
						}
						$update .= $name[$i]."=".$val;
					}
				}
				else if($type[$i] == "datetime")
				{
					$val = get_post_date_time($tableid."data_".$name[$i]);
					if($val != $row[$i])
					{
						if(strlen($update) > 0)
						{
							$update .= ",";
						}
						$update .= $name[$i]."='".$val."'";
					}
				}
				else
				{
					// I don't know how to save this data...
				}
			}
		}
		else
		{
			echo "No row to match WHERE $where<br>\n";
		}

		if(strlen($update) > 0)
		{
			$sql = "UPDATE $table_data SET $update WHERE $where";
			execute_insert($sql);
		}
	 }


function js_update_cell($id, $text, $color = "")
{
	if($text == "")
	{
		$text = "&nbsp;";
	}
	else
	{
		$text = strtr($text, array('"' => '\"'));
	}
	echo "<SCRIPT type=\"text/javascript\">\n";
	echo "<!--\n";
	echo "var x = document.getElementById(\"$id\");\n";
	if(strlen($color) > 0)
	{
		echo "x.style.backgroundColor=\"$color\";\n";
	}
	echo "x.innerHTML=\"$text\";\n";
	echo "//-->\n";
	echo "</SCRIPT>\n";
	flush();
}



class Table
{
	var $caption;
	var $bordercolor;
	var $colors;
	var $default_color;
	var $highlight_color;
	var $color_id;
	var $thin;
	var $body;
	var $head;
	var $row_tags;
	var $rows;
	var $class;
	var $downloadable;
	var $csvname;
	var $csv;
	var $table_width;
	var $uid;

	function Table($thin = false, $color_scheme = "oai")
	{
		global $default_background_colors, $highlight_background_colors;

//		$this->thin = $thin;
		$this->thin = false;
		$this->body = "";
		$this->head = "";
		$this->color_id = 0;
		$this->row_tags = "";
		$this->rows = 0;
		$this->class = "";
		$this->caption = "";
		$this->downloadable = false;
		$this->csv = "";
		$this->table_width = 0;
		$this->uid = "test";

		if($thin && $color_scheme == "")
		{
			$color_scheme = "thin";
		}

		if($color_scheme == "oai")
		{
			$this->bordercolor = "#990099";
			$this->default_color = $default_background_colors;
			$this->highlight_color = $highlight_background_colors;
			$this->colors = $this->default_color; //array("#FFEFFF", "#FFDFFF"); // background colors
			$this->head_color = array("#FFFFFF", "#990099"); // foreground, background
		}
		else if($color_scheme == "john")
		{
			$this->bordercolor = "";
			$this->default_color = array("#FFFFDD", "#E5E5E5");
			$this->highlight_color = $highlight_background_colors;
			$this->colors = $this->default_color;
			$this->head_color = "";
		}
		else if($color_scheme == "thin")
		{
			$this->thin = true;
			$this->bordercolor = "";
			$this->colors = array("#FFFFFF"); // background colors
			$this->head_color = "";
		}
		else
		{
			$this->class = $color_scheme;
			$this->bordercolor = "";
//			$this->default_color = array("#FFFFFF");
//			$this->highlight_color = array($green);
//			$this->colors = $this->default_color;
			$this->colors = array("row-1", "row-2"); // table row classes
			$this->head_color = "";
		}
		
	}

	function dump_else($text)
	{
		if($this->rows > 0)
		{
			$this->dump();
			return true;
		}
		else
		{
			if(strlen($text) > 0)
			{
				caption($text);
			}
		}
		return false;
	}

	function dump()
	{
		global $suppliment, $suppliment_name;

		if(strlen($this->class) > 0)
		{
			if($this->uid == "")
			{
				$u = "";
			}
			else
			{
				$u = " id=\"{$this->uid}\"";
			}
			open_entity("table class=\"$this->class\"$u");
		}
		else
		{
			if($this->thin)
			{
				thin_table();
			}
			else
			{
				table($this->bordercolor);
			}
		}
		if(strlen($this->caption) > 0)
		{
			open_entity("caption");
			itext($this->caption);
			close_entity("caption");
		}
		if(strlen($this->head) > 0)
		{
			open_entity("thead");
			echo $this->head;
			close_entity("thead");
		}



		if(strlen($this->csvname) > 0)
		{
			if($_SERVER["REQUEST_METHOD"] == "GET")
			{
				/* we need to re-post or get with the same options, but an extra item csvdownload='name' */
				$url = $_SERVER["REQUEST_URI"]."&csvdownload=".$this->csvname;
				open_entity("tfoot");
				tr();
				echo get_td_class("", $this->table_width);
				echo href($url, "Download CSV");
				echo get_etd_class();
				etr();
				close_entity("tfoot");
			}
			else if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				/* a bit harder... we need a form */
				$f = get_form();
				foreach($_POST as $key => $value)
				{
					$f.= get_insert_hidden($key, $value);
				}
				$f.= get_insert_hidden("csvdownload", $this->csvname);
				$f.= get_submit_button("Download CSV");
				$f.= get_eform();

				open_entity("tfoot");
				tr();
				echo get_td_class("", $this->table_width);
				echo $f;
				echo get_etd_class();
				etr();
				close_entity("tfoot");

			}

			if($this->downloadable)
			{
				$suppliment = $this->csv;
				$suppliment_name = $this->csvname;
			}
		}

		if(strlen($this->body) > 0)
		{
			open_entity("tbody");
			echo $this->body;
			close_entity("tbody");
		}
		etable();
	}

	function get_contents()
	{
		// only works with css tables

		$r = "";

		if(strlen($this->caption) > 0)
		{
			$r.= get_open_entity("caption");
			$r.= get_itext($this->caption);
			$r.= get_close_entity("caption");
		}
		if(strlen($this->head) > 0)
		{
			$r.= get_open_entity("thead");
			$r.= $this->head;
			$r.= get_close_entity("thead");
		}
		if(strlen($this->body) > 0)
		{
			$r.= get_open_entity("tbody");
			$r.= $this->body;
			$r.= get_close_entity("tbody");
		}
		return $r;
	}

	function caption($text)
	{
		$this->caption = $text;
	}

	function head($data, $span = "")
	{
		if(strlen($this->class) > 0)
		{
			$this->head .= get_table_head_class($data, $this->class, $span);
		}
		else
		{
			// prefix the head row to the body
			$this->body = get_table_head($data, $this->head_color).$this->body;
		}

		// there is no way in csv to indicate a header row
		if($this->downloadable)
		{
			$c = "";
			foreach($data as $i => $d)
			{
				if(strlen($c) > 0)
				{
					$c.= ",";
				}
				$c.= '"'.strtr($d, array('"' => '""')).'"';

				if(is_array($span))
				{
					for($s = 1; $s < $span[$i]; $s++)
					{
						$c.= ",";
					}
				}
			}
			$this->csv.= $c."\n";
		}
	}

	function row($data, $span = "", $id = "")
	{
		if(strlen($this->class) > 0)
		{
			// this reuses $this->colors as the row id
			if(!is_array($this->row_tags) && strlen($this->row_tags) > 0)
			{
				$tag = $this->row_tags;
				$this->row_tags = array();
				if(is_array($span))
				{
					foreach($span as $s)
					{
						for($i = 0; $i < $s; $i++)
						{
							$this->row_tags[] = $tag;
						}
					}
				}
				else
				{
					foreach($data as $d)
					{
						$this->row_tags[] = $tag;
					}
				}
			}
			$this->body .= get_table_row_class($data, $this->colors[$this->color_id], $span, $this->row_tags, $id);
			$this->color_id = ($this->color_id + 1) % sizeof($this->colors);
			$this->rows++;
		}
		else
		{
			$this->body .= get_table_row($data, $this->colors[$this->color_id], $this->row_tags, $span)."\n";
			$this->color_id = ($this->color_id + 1) % sizeof($this->colors);
			$this->rows++;
		}

		if($this->downloadable)
		{
			$c = "";
			foreach($data as $d)
			{
				// if $d is a hyperlink, then we only want the text...
				$d = strip_tags($d);
				if(strlen($c) > 0)
				{
					$c.= ",";
				}
				$c.= '"'.strtr($d, array('"' => '""')).'"';
			}
			$this->csv.= $c."\n";
		}

		if(!is_array($span))
		{
			$this->table_width = sizeof($data);
		}
	}

	function colorise($data)
	{
		// NYI.  Convert to css
	}

    function row_with_id($data, $id_prefix)
	{
		// NYI.  Convert to css???
		$this->row($data);
	}

	function download($name)
	{
		$this->csvname = $name;

		if(POG('csvdownload') == $name)
		{
			$this->downloadable = true;
		}
	}

	function get_csv()
	{
		return $this->csv;
	}
}

function tag_legend($style, $key)
{
	$t = new Table(true, $style);
	$t->head(array("Ledgend"));
	foreach($key as $tag => $text)
	{
		$t->row_tags = $tag;
		$t->row(array($text));
	}
	$t->dump();
}


class LinkSet
{
	var $names;
	var $links;
	var $icons;
	var $help;

	function LinkSet($names = array())
	{
		$this->names = $names;
	}

	function add_name($name)
	{
		array_push($this->names, $name);
	}

	function icons($icons)
	{
		if(!is_ns4())
		{
			$this->icons = $icons;
		}
	}

	function help($help)
	{
		$this->help = $help;
	}
	
	function get_dynamic($links)
	{
		$spc = "&nbsp;";
		$r = "";
		for($i = 0; $i < sizeof($links); $i++)
		{
			if($i == 0)
			{
				$r.= '['.$spc."\n";
			}
			else
			{
				$r.= get_itext($spc.'|'.$spc);
			}
			$r .= "<span class=\"dynamic\" style=\"cursor: pointer\" onclick=\"dynamic('$links[$i]')\">";
			$r .= $this->names[$i];
			$r .= "</span>";
		}
		$r.= get_itext($spc.']');
		return $r;
	}
	
	function get($links)
	{
		if(is_array($this->icons))
		{
			return $this->get_icons($links);
		}
		$spc = "&nbsp;";
		$r = "";
		for($i = 0; $i < sizeof($links); $i++)
		{
			if($i == 0)
			{
				$r.= '['.$spc."\n";
			}
			else
			{
				$r.= get_itext($spc.'|'.$spc);
			}
//			$r .= "<a href=\"".$links[$i]."\">".$this->names[$i]."</a>";
			$r .= href($links[$i], $this->names[$i]);
		}
		$r.= get_itext($spc.']');
		return $r;
	}

	function get_icons($links)
	{
		$r = "";
		foreach($links as $i => $url)
		{
			// 15
			$icon = $this->icons[$i];
			$text = $this->names[$i];

			if(is_array($this->help))
			{
				$help = $this->help[$i];
			}
			else
			{
				$help = $text;
			}
			preload_icon($icon);
			$r.= href($url, "<img src=\"/images/icons/spacer.gif\" alt=\"$text\" title=\"$help\" class=\"icon_$icon\">");
		}
		return $r;
	}
}

function get_icon_button($name, $icon, $url)
{
	$links = new LinkSet(array($name));
	$links->icons(array($icon));
	return $links->get(array($url));
}

function icon_button($name, $icon, $url)
{
	echo get_icon_button($name, $icon, $url);
}

function get_submit_button_icon($caption, $icon)
{
	if(is_ns4())
	{
		return get_submit_button($caption);
	}
	else
	{
		preload_icon($icon);
		return get_entity("input type=\"submit\" value=\"\" alt=\"$caption\" title=\"$caption\" class=\"icon_$icon\"");
	}
}

$preloaded_icons = array();
function preload_icon($icon)
{
	global $preloaded_icons;
	if(!in_array($icon, $preloaded_icons))
	{
		$preloaded_icons[] = $icon;
		echo get_entity("img src=\"/images/icons/spacer.gif\" alt=\"preloaded icon\" class=\"icon_{$icon}_preload\"");
	}
}

function confirm($msg, $event="onclick")
{
	return "\" $event=\"return confirm('Are you sure you want to $msg?')";
}

function script($text)
{
	open_entity('script type="text/javascript"');
	echo "<!--\n";
	echo "$text\n";
	echo "// -->\n";
	close_entity('script');
}

function get_script($text)
{
    $r = get_open_entity('script type="text/javascript"');
    $r.= "<!--\n";
    $r.= "$text\n";
    $r.= "// -->\n";
    $r.= get_close_entity('script');

    return $r;
}


function set_form_focus($form, $component)
{
	script("document.$form.$component.focus();\n");
}


/*
 * if defined then return $_POST[$value] else
 * return $_GET[$value]
 */
function POG($value)
{
	if(isset($_POST[$value]))
	{
		return $_POST[$value];
	}
	else if(isset($_GET[$value]))
	{
		return $_GET[$value];
	}
	else
	{
		return "";
	}
}

// auto validator magic
$valid_started = false;
function start_valid()
{
	global $valid_started;
	ob_start();
	$valid_started = true;
}

function end_valid()
{
	global $valid_started;

	if($valid_started)
	{
		$html = ob_get_contents();
		ob_end_clean();//ob_end_flush();

		$end_body = strpos($html, '</body>');
		if($end_body > 0)
		{
			echo substr($html, 0, $end_body);
			$rest = substr($html, $end_body, strlen($html));
		}
		else
		{
			echo $html;
			$rest = "";
		}
		script('window.defaultStatus = "Validating";');
		flush();


		$tmpfname = tempnam("/tmp", "valid");
		$tmp = fopen($tmpfname, "w");
		fwrite($tmp, $html);
		fclose($tmp);
		$url = "http://validator.ict.swin.edu.au/validator-new/check";
		$postData = array();
		$postData[ 'uploaded_file' ] = "@$tmpfname;type=text/html";
		$postData[ 'submit' ] = "Check";
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url );
		curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
		curl_setopt($ch, CURLOPT_POST, 1 );
		curl_setopt($ch, CURLOPT_POSTFIELDS, $postData );
		$response = curl_exec( $ch );
		if(strpos($response, "This Page Is Valid") === false)
		{
			$start = strpos($response, '<body>');
			$end  = strpos($response, '</body>');
			if($start > 0 && $end > $start)
			{
				$response = substr($response, $start + 6, $end - $start - 6);
			}
			//$response = str_replace('<style type="text/css" media="all">@import "./base.css";</style>', '', $response);
			echo $response;
			script('window.defaultStatus = "Done - Not Valid";');
		}
		else
		{
			// can we use some javascript here?
			script('window.defaultStatus = "Done - Validated";');
			if(preg_match('/src="(http:\/\/www.w3.org\/Icons\/valid-.*)"/', $response, $matches))
			{
				echo '<img src="'.$matches[1].'" alt="Page Valididated by W3C" height="31" width="88" id="valid">';
			}
		}
		unlink($tmpfname);
		echo $rest;
	}
}

function get_column_list($items, $columns = 2)
{
    if($columns < 1)
    {
        $columns = 1;
    }
    $per_column = sizeof($items) / $columns;

    $r = "";
    $in_list = false;
    foreach($items as $item)
    {
        if(!$in_list)
        {
			if($columns == 1)
			{
            	$r.= get_open_entity("ul class=\"single\"");
			}
			else
			{
            	$r.= get_open_entity("ul class=\"columns\"");
			}
            $in_list = true;
            $i = 0;
        }
        $r.= get_open_entity("li");
        $r.= $item;
        $r.= get_close_entity("li");

        $i++;
        if($i >= $per_column)
        {
            $r.= get_close_entity("ul");
            $in_list = false;
        }

    }
    if($in_list)
    {
        $r.= get_close_entity("ul");
    }
	if($columns != 1)
	{
    	$r.= get_entity("br class=\"columns\"");
	}
    return $r;
}

?>
